; NASCOM ROM BASIC Ver 4.7, (C) 1978 Microsoft
; Scanned from source published in 80-BUS NEWS from Vol 2, Issue 3
; (May-June 1983) to Vol 3, Issue 3 (May-June 1984)
; Adapted for the freeware Zilog Macro Assembler 2.10 to produce
; the original ROM code (checksum A934H). PA

; MONITOR EQUATES (RESTART INSTRUCTIONS)

_ROUT   equ     $F7            ; ROUT - Output char in A
_BLNK   equ     $7BDF          ; SCAL BLINK - Get input char in A
_INLN   equ     $63DF          ; SCAL INLIN - Get input line
_MFLP   equ     $5FDF          ; SCAL MFLP - Toggle tape drv LED
_MRET   equ     $5BDF          ; SCAL MRET - Return to monitor
_READ   equ     $52DF          ; SCAL READ
_RIN    equ     $62DF          ; SCAL RIN - Scan for input char
_VRFY   equ     $56DF          ; SCAL VERIFY
_WRIT   equ     $57DF          ; SCAL WRITE

; GENERAL EQUATES

UARTD   equ     $01             ; UART data port
UARTS   equ     $02             ; UART status port
CTRLC   equ     $03             ; Control "C"
CTRLG   equ     $07             ; Control "G"
BKSP    equ     $08             ; Back space
LF      equ     $0A             ; Line feed
CS      equ     $0C             ; Clear screen
CR      equ     $0D             ; Carriage return
CTRLO   equ     $0F             ; Control "O"
CTRLR   equ     $12             ; Control "R"
CTRLS   equ     $13             ; Control "S"
CTRLU   equ     $15             ; Control "U"
CTRLZ   equ     $1A             ; Control "Z"
ESC     equ     $1B             ; Escape
TBRK    equ     $1C             ; "T" monitor break
TBS     equ     $1D             ; "T" monitor back space
TCS     equ     $1E             ; "T" monitor clear screen
TCR     equ     $1F             ; "T" monitor carriage return
DEL     equ     $7F             ; Delete

; MONITOR LOCATIONS

MONSTT  equ     $0000           ; Start of monitor
STMON   equ     $000D           ; NAS-SYS initialisation
MFLP    equ     $0051           ; Flip tape LED ("T")
MONTYP  equ     $008D           ; Type of "T" monitor
T2DUMP  equ     $03D1           ; "T2" Dump routine
T4WR    equ     $0400           ; "T4" Write routine
T4READ  equ     $070C           ; "T4" Read routine
VDU     equ     $0800           ; NASCOM Video RAM base

; MONITOR WORK SPACE LOCATIONS

PORT0   equ     $0C00           ; Copy of output port 0
ARG1    equ     $0C0C           ; Argument 1
ARG2    equ     $0C0E           ; Argument 2
TCUR    equ     $0C18           ; "T" monitor cursor
CURSOR  equ     $0C29           ; NAS-SYS Cursor
ARGN    equ     $0C2B           ; Number of ARGS
TOUT    equ     $0C4A           ; "T" Output reflection
TIN     equ     $0C4D           ; "T" Input reflection
CIN     equ     $0C75           ; NAS-SYS Input table
NMI     equ     $0C7E           ; NAS-SYS NMI Jump

; BASIC WORK SPACE LOCATIONS

WRKSPC  equ     $1000           ; BASIC Work space
USR     equ     $1003           ; "USR (x)" jump
OUTSUB  equ     $1006           ; "OUT p,n"
OTPORT  equ     $1007           ; Port (p)
DIVSUP  equ     $1009           ; Division support routine
DIV1    equ     $100A           ; <- Values
DIV2    equ     $100E           ; <-   to
DIV3    equ     $1012           ; <-   be
DIV4    equ     $1015           ; <-inserted
SEED    equ     $1017           ; Random number seed
LSTRND  equ     $103A           ; Last random number
INPSUB  equ     $103E           ; #INP (x)" Routine
INPORT  equ     $103F           ; PORT (x)
NULLS   equ     $1041           ; Number of nulls
LWIDTH  equ     $1042           ; Terminal width
COMMAN  equ     $1043           ; Width for commas
NULFLG  equ     $1044           ; Null after input byte flag
CTLOFG  equ     $1045           ; Control "O" flag
LINESC  equ     $1046           ; Lines counter
LINESN  equ     $1048           ; Lines number
CHKSUM  equ     $104A           ; Array load/save check sum
NMIFLG  equ     $104C           ; Flag for NMI break routine
BRKFLG  equ     $104D           ; Break flag
RINPUT  equ     $104E           ; Input reflection
POINT   equ     $1051           ; "POINT" reflection (unused)
PSET    equ     $1054           ; "SET"   reflection
RESET   equ     $1057           ; "RESET" reflection
STRSPC  equ     $105A           ; Bottom of string space
LINEAT  equ     $105C           ; Current line number
BASTXT  equ     $105E           ; Pointer to start of program
BUFFER  equ     $1061           ; Input buffer
STACK   equ     $1066           ; Initial stack
CURPOS  equ     $10AB           ; Character position on line
LCRFLG  equ     $10AC           ; Locate/Create flag
TYPE    equ     $10AD           ; Data type flag
DATFLG  equ     $10AE           ; Literal statement flag
LSTRAM  equ     $10AF           ; Last available RAM
TMSTPT  equ     $10B1           ; Temporary string pointer
TMSTPL  equ     $10B3           ; Temporary string pool
TMPSTR  equ     $10BF           ; Temporary string
STRBOT  equ     $10C3           ; Bottom of string space
CUROPR  equ     $10C5           ; Current operator in EVAL
LOOPST  equ     $10C7           ; First statement of loop
DATLIN  equ     $10C9           ; Line of current DATA item
FORFLG  equ     $10CB           ; "FOR" loop flag
LSTBIN  equ     $10CC           ; Last byte entered
READFG  equ     $10CD           ; Read/Input flag
BRKLIN  equ     $10CE           ; Line of break
NXTOPR  equ     $10D0           ; Next operator in EVAL
ERRLIN  equ     $10D2           ; Line of error
CONTAD  equ     $10D4           ; Where to CONTinue
PROGND  equ     $10D6           ; End of program
VAREND  equ     $10D8           ; End of variables
ARREND  equ     $10DA           ; End of arrays
NXTDAT  equ     $10DC           ; Next data item
FNRGNM  equ     $10DE           ; Name of FN argument
FNARG   equ     $10E0           ; FN argument value
FPREG   equ     $10E4           ; Floating point register
FPEXP   equ     FPREG+3         ; Floating point exponent
SGNRES  equ     $10E8           ; Sign of result
PBUFF   equ     $10E9           ; Number print buffer
MULVAL  equ     $10F6           ; Multiplier
PROGST  equ     $10F9           ; Start of program text area
STLOOK  equ     $115D           ; Start of memory test

; BASIC ERROR CODE VALUES

NF      equ     $00             ; NEXT without FOR
SN      equ     $02             ; Syntax error
RG      equ     $04             ; RETURN without GOSUB
OD      equ     $06             ; Out of DATA
FC      equ     $08             ; Function call error
OV      equ     $0A             ; Overflow
OM      equ     $0C             ; Out of memory
UL      equ     $0E             ; Undefined line number
BS      equ     $10             ; Bad subscript
DD      equ     $12             ; Re-DIMensioned array
DZ      equ     $14             ; Division by zero (/0)
ID      equ     $16             ; Illegal direct
TM      equ     $18             ; Type miss-match
OS      equ     $1A             ; Out of string space
LS      equ     $1C             ; String too long
ST      equ     $1E             ; String formula too complex
CN      equ     $20             ; Can't CONTinue
UF      equ     $22             ; UnDEFined FN function
MO      equ     $24             ; Missing operand

        org     $E000

START:  jp      STARTB          ; Jump for restart jump
STARTB: di                      ; No interrupts
        ld      ix,0            ; Flag cold start
        jp      CSTART          ; Jump to initialise

        dw      DEINT           ; Get integer -32768 to 32767
        dw      ABPASS          ; Return integer in AB

        jp      LDNMI1          ; << NO REFERENCE TO HERE >>

CSTART: ld      hl,WRKSPC       ; Start of workspace RAM
        ld      sp,hl           ; Set up a temporary stack
        jp      INITST          ; Go to initialise

INIT:   ld      de,INITAB       ; Initialise workspace
        ld      b,INITBE-INITAB+3; Bytes to copy
        ld      hl,WRKSPC       ; Into workspace RAM
COPY:   ld      a,(de)          ; Get source
        ld      (hl),a          ; To destination
        inc     hl              ; Next destination
        inc     de              ; Next source
        dec     b               ; Count bytes
        jp      nz,COPY         ; More to move
        ld      sp,hl           ; Temporary stack
        call    CLREG           ; Clear registers and stack
        call    PRNTCR          ; Output CRLF
        ld      (BUFFER+72+1),a ; Mark end of buffer
        ld      (PROGST),a      ; Initialise program area
MSIZE:  ld      hl,MEMMSG       ; Point to message
        call    PRS             ; Output "Memory size"
        call    PROMPT          ; Get input with "?"
        call    GETCHR          ; Get next character
        or      a               ; Set flags
        jp      nz,TSTMEM       ; If number - Test if RAM there
        ld      hl,STLOOK       ; Point to start of RAM
MLOOP:  inc     hl              ; Next byte
        ld      a,h             ; Above address FFFF ?
        or      l
        jp      z,SETTOP        ; Yes - 64K RAM
        ld      a,(hl)          ; Get contents
        ld      b,a             ; Save it
        cpl                     ; Flip all bits
        ld      (hl),a          ; Put it back
        cp      (hl)            ; RAM there if same
        ld      (hl),b          ; Restore old contents
        jp      z,MLOOP         ; If RAM - test next byte
        jp      SETTOP          ; Top of RAM found

TSTMEM: call    ATOH            ; Get high memory into DE
        or      a               ; Set flags on last byte
        jp      nz,SNERR        ; ?SN Error if bad character
        ex      de,hl           ; Address into HL
        dec     hl              ; Back one byte
        ld      a,%11011001     ; Test byte
        ld      b,(hl)          ; Get old contents
        ld      (hl),a          ; Load test byte
        cp      (hl)            ; RAM there if same
        ld      (hl),b          ; Restore old contents
        jp      nz,MSIZE        ; Ask again if no RAM

SETTOP: dec     hl              ; Back one byte
        ld      de,STLOOK-1     ; See if enough RAM
        call    CPDEHL          ; Compare DE with HL
        jp      c,MSIZE         ; Ask again if not enough RAM
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        ld      de,0-50         ; 50 Bytes string space
        ld      (LSTRAM),hl     ; Save last available RAM
        add     hl,de           ; Allocate string space
        ld      (STRSPC),hl     ; Save string space
        call    CLRPTR          ; Clear program area
        ld      hl,(STRSPC)     ; Get end of memory
        ld      de,0-17         ; Offset for free bytes
        add     hl,de           ; Adjust HL
        ld      de,PROGST       ; Start of program text
        ld      a,l             ; Get LSB
        sub     e               ; Adjust it
        ld      l,a             ; Re-save
        ld      a,h             ; Get MSB
        sbc     a,d             ; Adjust it
        ld      h,a             ; Re-save
        push    hl              ; Save bytes free
        ld      hl,SIGNON       ; Sign-on message
        call    PRS             ; Output string
        pop     hl              ; Get bytes free back
        call    PRNTHL          ; Output amount of free memory
        ld      hl,BFREE        ; " Bytes free" message
        call    PRS             ; Output string

WARMST: ld      sp,STACK        ; Temporary stack
BRKRET: call    CLREG           ; Clear registers and stack
        jp      PRNTOK          ; Go to get command line

BFREE:  db      " Bytes free",CR,0,0

SIGNON: db      "NASCOM ROM BASIC Ver 4.7   ",CR
        db      "Copyright (C) 1978 by Microsoft",CR,0,0

MEMMSG: db      "Memory size",0

; FUNCTION ADDRESS TABLE

FNCTAB: dw      SGN
        dw      fint
        dw      fabs
        dw      USR
        dw      FRE
        dw      INP
        dw      POS
        dw      SQR
        dw      RND
        dw      flog
        dw      fexp
        dw      fcos
        dw      fsin
        dw      ftan
        dw      ATN
        dw      PEEK
        dw      DEEK
        dw      POINT
        dw      LEN
        dw      STR
        dw      VAL
        dw      ASC
        dw      fCHR
        dw      LEFT
        dw      RIGHT
        dw      MID

; RESERVED WORD LIST

WORDS:  db      "E"+$80,"ND"
        db      "F"+$80,"OR"
        db      "N"+$80,"EXT"
        db      "D"+$80,"ATA"
        db      "I"+$80,"NPUT"
        db      "D"+$80,"IM"
        db      "R"+$80,"EAD"
        db      "L"+$80,"ET"
        db      "G"+$80,"OTO"
        db      "R"+$80,"UN"
        db      "I"+$80,"F"
        db      "R"+$80,"ESTORE"
        db      "G"+$80,"OSUB"
        db      "R"+$80,"ETURN"
        db      "R"+$80,"EM"
        db      "S"+$80,"TOP"
        db      "O"+$80,"UT"
        db      "O"+$80,"N"
        db      "N"+$80,"ULL"
        db      "W"+$80,"AIT"
        db      "D"+$80,"EF"
        db      "P"+$80,"OKE"
        db      "D"+$80,"OKE"
        db      "S"+$80,"CREEN"
        db      "L"+$80,"INES"
        db      "C"+$80,"LS"
        db      "W"+$80,"IDTH"
        db      "M"+$80,"ONITOR"
        db      "S"+$80,"ET"
        db      "R"+$80,"ESET"
        db      "P"+$80,"RINT"
        db      "C"+$80,"ONT"
        db      "L"+$80,"IST"
        db      "C"+$80,"LEAR"
        db      "C"+$80,"LOAD"
        db      "C"+$80,"SAVE"
        db      "N"+$80,"EW"
        db      "T"+$80,"AB("
        db      "T"+$80,"O"
        db      "F"+$80,"N"
        db      "S"+$80,"PC("
        db      "T"+$80,"HEN"
        db      "N"+$80,"OT"
        db      "S"+$80,"TEP"

        db      "+"+$80
        db      "-"+$80
        db      "*"+$80
        db      "/"+$80
        db      "^"+$80
        db      "A"+$80,"ND"
        db      "O"+$80,"R"
        db      ">"+$80
        db      "="+$80
        db      "<"+$80

        db      "S"+$80,"GN"
        db      "I"+$80,"NT"
        db      "A"+$80,"BS"
        db      "U"+$80,"SR"
        db      "F"+$80,"RE"
        db      "I"+$80,"NP"
        db      "P"+$80,"OS"
        db      "S"+$80,"QR"
        db      "R"+$80,"ND"
        db      "L"+$80,"OG"
        db      "E"+$80,"XP"
        db      "C"+$80,"OS"
        db      "S"+$80,"IN"
        db      "T"+$80,"AN"
        db      "A"+$80,"TN"
        db      "P"+$80,"EEK"
        db      "D"+$80,"EEK"
        db      "P"+$80,"OINT"
        db      "L"+$80,"EN"
        db      "S"+$80,"TR$"
        db      "V"+$80,"AL"
        db      "A"+$80,"SC"
        db      "C"+$80,"HR$"
        db      "L"+$80,"EFT$"
        db      "R"+$80,"IGHT$"
        db      "M"+$80,"ID$"
        db      $80             ; End of list marker

; KEYWORD ADDRESS TABLE

WORDTB: dw      fpend
        dw      ffor
        dw      fnext
        dw      DATA
        dw      INPUT
        dw      DIM
        dw      READ
        dw      LET
        dw      GOTO
        dw      RUN
        dw      fif
        dw      RESTOR
        dw      GOSUB
        dw      RETURN
        dw      REM
        dw      STOP
        dw      POUT
        dw      ON
        dw      NULL
        dw      WAIT
        dw      fdef
        dw      POKE
        dw      DOKE
        dw      SCREEN
        dw      LINES
        dw      CLS
        dw      WIDTH
        dw      MONITR
        dw      PSET
        dw      RESET
        dw      PRINT
        dw      CONT
        dw      LIST
        dw      CLEAR
        dw      CLOAD
        dw      CSAVE
        dw      NEW

; RESERVED WORD TOKEN VALUES

ZEND    equ     $80            ; END
ZFOR    equ     $81            ; FOR
ZDATA   equ     $83            ; DATA
ZGOTO   equ     $88            ; GOTO
ZGOSUB  equ     $8C            ; GOSUB
ZREM    equ     $8E            ; REM
ZPRINT  equ     $9E            ; PRINT
ZNEW    equ     $A4            ; NEW

ZTAB    equ     $A5            ; TAB
ZTO     equ     $A6            ; TO
ZFN     equ     $A7            ; FN
ZSPC    equ     $A8            ; SPC
ZTHEN   equ     $A9            ; THEN
ZNOT    equ     $AA            ; NOT
ZSTEP   equ     $AB            ; STEP

ZPLUS   equ     $AC            ; +
ZMINUS  equ     $AD            ; -
ZTIMES  equ     $AE            ; *
ZDIV    equ     $AF            ; /
ZOR     equ     $B2            ; OR
ZGTR    equ     $B3            ; >
ZEQUAL  equ     $B4            ; M
ZLTH    equ     $B5            ; <
ZSGN    equ     $B6            ; SGN
ZPOINT  equ     $C7            ; POINT
ZLEFT   equ     $CD            ; LEFT$

; ARITHMETIC PRECEDENCE TABLE

PRITAB: db      $79             ; Precedence value
        dw      PADD            ; FPREG = <last> + FPREG

        db      $79             ; Precedence value
        dw      PSUB            ; FPREG = <last> - FPREG

        db      $7C             ; Precedence value
        dw      MULT            ; PPREG = <last> * FPREG

        db      $7C             ; Precedence value
        dw      DIV             ; FPREG = <last> / FPREG

        db      $7F             ; Precedence value
        dw      POWER           ; FPREG = <last> ^ FPREG

        db      $50             ; Precedence value
        dw      PAND            ; FPREG = <last> AND FPREG

        db      $46             ; Precedence value
        dw      POR             ; FPREG = <last> OR FPREG

; BASIC ERROR CODE LIST

ERRORS: db      "NF"            ; NEXT without FOR
        db      "SN"            ; Syntax error
        db      "RG"            ; RETURN without GOSUB
        db      "OD"            ; Out of DATA
        db      "FC"            ; Illegal function call
        db      "OV"            ; Overflow error
        db      "OM"            ; Out of memory
        db      "UL"            ; Undefined line
        db      "BS"            ; Bad subscript
        db      "DD"            ; Re-DIMensioned array
        db      "/0"            ; Division by zero
        db      "ID"            ; Illegal direct
        db      "TM"            ; Type mis-match
        db      "OS"            ; Out of string space
        db      "LS"            ; String too long
        db      "ST"            ; String formula too complex
        db      "CN"            ; Can't CONTinue
        db      "UF"            ; Undefined FN function
        db      "MO"            ; Missing operand

; INITIALISATION TABLE

INITAB: jp      WARMST          ; Warm start jump
        jp      FCERR           ; "USR (X)" jump (Set to Error)

        out     (0),a           ; "OUT p,n" skeleton
        ret

        sub     0               ; Division support routine
        ld      l,a
        ld      a,h
        sbc     a,0
        ld      h,a
        ld      a,b
        sbc     a,0
        ld      b,a
        ld      a,0
        ret

        db      0,0,0                   ; Random number seed
                                        ; Table used by RND
        db      $35,$4A,$CA,$99     ;-2.65145E+07
        db      $39,$1C,$76,$98     ; 1.61291E+07
        db      $22,$95,$B3,$98     ;-1.17691E+07
        db      $0A,$DD,$47,$98     ; 1.30983E+07
        db      $53,$D1,$99,$99     ;-2-01612E+07
        db      $0A,$1A,$9F,$98     ;-1.04269E+07
        db      $65,$BC,$CD,$98     ;-1.34831E+07
        db      $D6,$77,$3E,$98     ; 1.24825E+07
        db      $52,$C7,$4F,$80     ; Last random number

        in      a,(0)           ; INP (x) skeleton
        ret

        db      1               ; POS (x) number (1)
        db      47              ; Terminal width (47)
        db      28              ; Width for commas (3 columns)
        db      0               ; No nulls after input bytes
        db      0               ; Output enabled (^O off)

        dw      5               ; Initial lines counter
        dw      5               ; Initial lines number
        dw      0               ; Array load/save check sum

        db      0               ; Break not by NMI
        db      0               ; Break flag

        jp      TTYLIN          ; Input reflection (set to TTY)
        jp      POINTB          ; POINT reflection unused
        jp      SETB            ; SET reflection
        jp      RESETB          ; RESET reflection

        dw      STLOOK          ; Temp string space
        dw      -2              ; Current line number (cold)
        dw      PROGST+1        ; Start of program text
INITBE:                         ; END OF INITIALISATION TABLE

ERRMSG: db      " Error",0
INMSG:  db      " in ",0
ZERBYT  equ     $-1             ; A zero byte
OKMSG:  db      "Ok",CR,0,0
BRKMSG: db      "Break",0

BAKSTK: ld      hl,4            ; Look for "FOR" block with
        add     hl,sp           ; same index as specified
LOKFOR: ld      a,(hl)          ; Get block ID
        inc     hl              ; Point to index address
        cp      ZFOR            ; Is it a "FOR" token
        ret     nz              ; No - exit
        ld      c,(hl)          ; BC = Address of "FOR" index
        inc     hl
        ld      b,(hl)
        inc     hl              ; Point to sign of STEP
        push    hl              ; Save pointer to sign
        ld      l,c             ; HL = address of "FOR" index
        ld      h,b
        ld      a,d             ; See if an index was specified
        or      e               ; DE = 0 if no index specified
        ex      de,hl           ; Specified index into HL
        jp      z,INDFND        ; Skip if no index given
        ex      de,hl           ; Index back into DE
        call    CPDEHL          ; Compare index with one given
INDFND: ld      bc,16-3         ; Offset to next block
        pop     hl              ; Restore pointer to sign
        ret     z               ; Return if block found
        add     hl,bc           ; Point to next block
        jp      LOKFOR          ; Keep on looking

MOVUP:  call    ENFMEM          ; See if enough memory
MOVSTR: push    bc              ; Save end of source
        ex      (sp),hl         ; Swap source and dest" end
        pop     bc              ; Get end of destination
MOVLP:  call    CPDEHL          ; See if list moved
        ld      a,(hl)          ; Get byte
        ld      (bc),a          ; Move it
        ret     z               ; Exit if all done
        dec     bc              ; Next byte to move to
        dec     hl              ; Next byte to move
        jp      MOVLP           ; Loop until all bytes moved

CHKSTK: push    hl              ; Save code string address
        ld      hl,(ARREND)     ; Lowest free memory
        ld      b,0             ; BC = Number of levels to test
        add     hl,bc           ; 2 Bytes for each level
        add     hl,bc
        db      $3E             ; Skip "PUSH HL"
ENFMEM: push    hl              ; Save code string address
        ld      a,low -48       ; 48 Bytes minimum RAM
        sub     l
        ld      l,a
        ld      a,high -48      ; 48 Bytes minimum RAM
        sbc     a,h
        jp      c,OMERR         ; Not enough - ?OM Error
        ld      h,a
        add     hl,sp           ; Test if stack is overflowed
        pop     hl              ; Restore code string address
        ret     c               ; Return if enough mmory
OMERR:  ld      e,OM            ; ?OM Error
        jp      ERROR

DATSNR: ld      hl,(DATLIN)     ; Get line of current DATA item
        ld      (LINEAT),hl     ; Save as current line
SNERR:  ld      e,SN            ; ?SN Error
        db      $01             ; Skip "LD E,DZ"
DZERR:  ld      e,DZ            ; ?/0 Error
        db      $01             ; Skip "LD E,NF"
NFERR:  ld      e,NF            ; ?NF Error
        db      $01             ; Skip "LD E,DD"
DDERR:  ld      e,DD            ; ?DD Error
        db      $01             ; Skip "LD E,UF"
UFERR:  ld      e,UF            ; ?UF Error
        db      $01             ; Skip "LD E,OV
OVERR:  ld      e,OV            ; ?OV Error
        db      $01             ; Skip "LD E,TM"
TMERR:  ld      e,TM            ; ?TM Error

ERROR:  call    CLREG           ; Clear registers and stack
        ld      (CTLOFG),a      ; Enable output (A is 0)
        call    STTLIN          ; Start new line
        ld      hl,ERRORS       ; Point to error codes
        ld      d,a             ; D = 0 (A is 0)
        ld      a,"?"
        call    OUTC            ; Output "?"
        add     hl,de           ; Offset to correct error code
        ld      a,(hl)          ; First character
        call    OUTC            ; Output it
        call    GETCHR          ; Get next character
        call    OUTC            ; Output it
        ld      hl,ERRMSG       ; "Error" message
ERRIN:  call    PRS             ; Output message
        ld      hl,(LINEAT)     ; Get line of error
        ld      de,-2           ; Cold start error if -2
        call    CPDEHL          ; See if cold start error
        jp      z,CSTART        ; Cold start error - Restart
        ld      a,h             ; Was it a direct error?
        and     l               ; Line = -1 if direct error
        inc     a
        call    nz,LINEIN       ; No - output line of error
        db      $3E             ; Skip "POP BC"
POPNOK: pop     bc              ; Drop address in input buffer

PRNTOK: xor     a               ; Output "Ok" and get command
        ld      (CTLOFG),a      ; Enable output
        call    STTLIN          ; Start new line
        ld      hl,OKMSG        ; "Ok" message
        call    PRS             ; Output "Ok"
GETCMD: ld      hl,-1           ; Flag direct mode
        ld      (LINEAT),hl     ; Save as current line
        call    GETLIN          ; Get an input line
        jp      c,GETCMD        ; Get line again if break
        call    GETCHR          ; Get first character
        inc     a               ; Test if end of line
        dec     a               ; Without affecting Carry
        jp      z,GETCMD        ; Nothing entered - Get another
        push    af              ; Save Carry status
        call    ATOH            ; Get line number into DE
        push    de              ; Save line number
        call    CRUNCH          ; Tokenise rest of line
        ld      b,a             ; Length of tokenised line
        pop     de              ; Restore line number
        pop     af              ; Restore Carry
        jp      nc,EXCUTE       ; No line number - Direct mode
        push    de              ; Save line number
        push    bc              ; Save length of tokenised line
        xor     a
        ld      (LSTBIN),a      ; Clear last byte input
        call    GETCHR          ; Get next character
        or      a               ; Set flags
        push    af              ; And save them
        call    SRCHLN          ; Search for line number in DE
        jp      c,LINFND        ; Jump if line found
        pop     af              ; Get status
        push    af              ; And re-save
        jp      z,ULERR         ; Nothing after number - Error
        or      a               ; Clear Carry
LINFND: push    bc              ; Save address of line in prog
        jp      nc,INEWLN       ; Line not found - Insert new
        ex      de,hl           ; Next line address in DE
        ld      hl,(PROGND)     ; End of program
SFTPRG: ld      a,(de)          ; Shift rest of program down
        ld      (bc),a
        inc     bc              ; Next destination
        inc     de              ; Next source
        call    CPDEHL          ; All done?
        jp      nz,SFTPRG       ; More to do
        ld      h,b             ; HL - New end of program
        ld      l,c
        ld      (PROGND),hl     ; Update end of program

INEWLN: pop     de              ; Get address of line,
        pop     af              ; Get status
        jp      z,SETPTR        ; No text - Set up pointers
        ld      hl,(PROGND)     ; Get end of program
        ex      (sp),hl         ; Get length of input line
        pop     bc              ; End of program to BC
        add     hl,bc           ; Find new end
        push    hl              ; Save new end
        call    MOVUP           ; Make space for line
        pop     hl              ; Restore new end
        ld      (PROGND),hl     ; Update end of program pointer
        ex      de,hl           ; Get line to move up in HL
        ld      (hl),h          ; Save MSB
        pop     de              ; Get new line number
        inc     hl              ; Skip pointer
        inc     hl
        ld      (hl),e          ; Save LSB of line number
        inc     hl
        ld      (hl),d          ; Save MSB of line number
        inc     hl              ; To first byte in line
        ld      de,BUFFER       ; Copy buffer to program
MOVBUF: ld      a,(de)          ; Get source
        ld      (hl),a          ; Save destinations
        inc     hl              ; Next source
        inc     de              ; Next destination
        or      a               ; Done?
        jp      nz,MOVBUF       ; No - Repeat
SETPTR: call    RUNFST          ; Set line pointers
        inc     hl              ; To LSB of pointer
        ex      de,hl           ; Address to DE
PTRLP:  ld      h,d             ; Address to HL
        ld      l,e
        ld      a,(hl)          ; Get LSB of pointer
        inc     hl              ; To MSB of pointer
        or      (hl)            ; Compare with MSB pointer
        jp      z,GETCMD        ; Get command line if end
        inc     hl              ; To LSB of line number
        inc     hl              ; Skip line number
        inc     hl              ; Point to first byte in line
        xor     a               ; Looking for 00 byte
FNDEND: cp      (hl)            ; Found end of line?
        inc     hl              ; Move to next byte
        jp      nz,FNDEND       ; No - Keep looking
        ex      de,hl           ; Next line address to HL
        ld      (hl),e          ; Save LSB of pointer
        inc     hl
        ld      (hl),d          ; Save MSB of pointer
        jp      PTRLP           ; Do next line

SRCHLN: ld      hl,(BASTXT)     ; Start of program text
SRCHLP: ld      b,h             ; BC = Address to look at
        ld      c,l
        ld      a,(hl)          ; Get address of next line
        inc     hl
        or      (hl)            ; End of program found?
        dec     hl
        ret     z               ; Yes - Line not found
        inc     hl
        inc     hl
        ld      a,(hl)          ; Get LSB of line number
        inc     hl
        ld      h,(hl)          ; Get MSB of line number
        ld      l,a
        call    CPDEHL          ; Compare with line in DE
        ld      h,b             ; HL = Start of this line
        ld      l,c
        ld      a,(hl)          ; Get LSB of next line address
        inc     hl
        ld      h,(hl)          ; Get MSB of next line address
        ld      l,a             ; Next line to HL
        ccf
        ret     z               ; Lines found - Exit
        ccf
        ret     nc              ; Line not found,at line after
        jp      SRCHLP          ; Keep looking

NEW:    ret     nz              ; Return if any more on line
CLRPTR: ld      hl,(BASTXT)     ; Point to start of program
        xor     a               ; Set program area to empty
        ld      (hl),a          ; Save LSB = 00
        inc     hl
        ld      (hl),a          ; Save MSB = 00
        inc     hl
        ld      (PROGND),hl     ; Set program end

RUNFST: ld      hl,(BASTXT)     ; Clear all variables
        dec     hl

INTVAR: ld      (BRKLIN),hl     ; Initialise RUN variables
        ld      hl,(LSTRAM)     ; Get end of RAM
        ld      (STRBOT),hl     ; Clear string space
        xor     a
        call    RESTOR          ; Reset DATA pointers
        ld      hl,(PROGND)     ; Get end of program
        ld      (VAREND),hl     ; Clear variables
        ld      (ARREND),hl     ; Clear arrays

CLREG:  pop     bc              ; Save return address
        ld      hl,(STRSPC)     ; Get end of working RAN
        ld      sp,hl           ; Set stack
        ld      hl,TMSTPL       ; Temporary string pool
        ld      (TMSTPT),hl     ; Reset temporary string ptr
        xor     a               ; A = 00
        ld      l,a             ; HL = 0000
        ld      h,a
        ld      (CONTAD),hl     ; No CONTinue
        ld      (FORFLG),a      ; Clear FOR flag
        ld      (FNRGNM),hl     ; Clear FN argument
        push    hl              ; HL = 0000
        push    bc              ; Put back return
DOAGN:  ld      hl,(BRKLIN)     ; Get address of code to RUN
        ret                     ; Return to execution driver

PROMPT: ld      a,"?"           ; "?"
        call    OUTC            ; Output character
        ld      a," "           ; Space
        call    OUTC            ; Output character
        jp      RINPUT          ; Get input line

CRUNCH: xor     a               ; Tokenise line @ HL to BUFFER
        ld      (DATFLG),a      ; Reset literal flag
        ld      c,2+3           ; 2 byte number and 3 nulls
        ld      de,BUFFER       ; Start of input buffer
CRNCLP: ld      a,(hl)          ; Get byte
        cp      " "             ; Is it a space?
        jp      z,MOVDIR        ; Yes - Copy direct
        ld      b,a             ; Save character
        cp      '"'             ; Is it a quote?
        jp      z,CPYLIT        ; Yes - Copy literal string
        or      a               ; Is it end of buffer?
        jp      z,ENDBUF        ; Yes - End buffer
        ld      a,(DATFLG)      ; Get data type
        or      a               ; Literal?
        ld      a,(hl)          ; Get byte to copy
        jp      nz,MOVDIR       ; Literal - Copy direct
        cp      "?"             ; Is it "?" short for PRINT
        ld      a,ZPRINT        ; "PRINT" token
        jp      z,MOVDIR        ; Yes - replace it
        ld      a,(hl)          ; Get byte again
        cp      "0"             ; Is it less than "0"
        jp      c,FNDWRD        ; Yes - Look for reserved words
        cp      ";"+1           ; Is it "0123456789:;" ?
        jp      c,MOVDIR        ; Yes - copy it direct
FNDWRD: push    de              ; Look for reserved words
        ld      de,WORDS-1      ; Point to table
        push    bc              ; Save count
        ld      bc,RETNAD       ; Where to return to
        push    bc              ; Save return address
        ld      b,ZEND-1        ; First token value -1
        ld      a,(hl)          ; Get byte
        cp      "a"             ; Less than "a" ?
        jp      c,SEARCH        ; Yes - search for words
        cp      "z"+1           ; Greater than "z" ?
        jp      nc,SEARCH       ; Yes - search for words
        and     %01011111       ; Force upper case
        ld      (hl),a          ; Replace byte
SEARCH: ld      c,(hl)          ; Search for a word
        ex      de,hl
GETNXT: inc     hl              ; Get next reserved word
        or      (hl)            ; Start of word?
        jp      p,GETNXT        ; No - move on
        inc     b               ; Increment token value
        ld      a, (hl)         ; Get byte from table
        and     %01111111       ; Strip bit 7
        ret     z               ; Return if end of list
        cp      c               ; Same character as in buffer?
        jp      nz,GETNXT       ; No - get next word
        ex      de,hl
        push    hl              ; Save start of word

NXTBYT: inc     de              ; Look through rest of word
        ld      a,(de)          ; Get byte from table
        or      a               ; End of word ?
        jp      m,MATCH         ; Yes - Match found
        ld      c,a             ; Save it
        ld      a,b             ; Get token value
        cp      ZGOTO           ; Is it "GOTO" token ?
        jp      nz,NOSPC        ; No - Don't allow spaces
        call    GETCHR          ; Get next character
        dec     hl              ; Cancel increment from GETCHR
NOSPC:  inc     hl              ; Next byte
        ld      a,(hl)          ; Get byte
        cp      "a"             ; Less than "a" ?
        jp      c,NOCHNG        ; Yes - don't change
        and     %01011111       ; Make upper case
NOCHNG: cp      c               ; Same as in buffer ?
        jp      z,NXTBYT        ; Yes - keep testing
        pop     hl              ; Get back start of word
        jp      SEARCH          ; Look at next word

MATCH:  ld      c,b             ; Word found - Save token value
        pop     af              ; Throw away return
        ex      de,hl
        ret                     ; Return to "RETNAD"
RETNAD: ex      de,hl           ; Get address in string
        ld      a,c             ; Get token value
        pop     bc              ; Restore buffer length
        pop     de              ; Get destination address
MOVDIR: inc     hl              ; Next source in buffer
        ld      (de),a          ; Put byte in buffer
        inc     de              ; Move up buffer
        inc     c               ; Increment length of buffer
        sub     ":"             ; End of statement?
        jp      z,SETLIT        ; Jump if multi-statement line
        cp      ZDATA-$3A       ; Is it DATA statement ?
        jp      nz,TSTREM       ; No - see if REM
SETLIT: ld      (DATFLG),a      ; Set literal flag
TSTREM: sub     ZREM-$3A        ; Is it REM?
        jp      nz,CRNCLP       ; No - Leave flag
        ld      b,a             ; Copy rest of buffer
NXTCHR: ld      a,(hl)          ; Get byte
        or      a               ; End of line ?
        jp      z,ENDBUF        ; Yes - Terminate buffer
        cp      b               ; End of statement ?
        jp      z,MOVDIR        ; Yes - Get next one
CPYLIT: inc     hl              ; Move up source string
        ld      (de),a          ; Save in destination
        inc     c               ; Increment length
        inc     de              ; Move up destination
        jp      NXTCHR          ; Repeat

ENDBUF: ld      hl,BUFFER-1     ; Point to start of buffer
        ld      (de),a          ; Mark end of buffer (A = 00)
        inc     de
        ld      (de),a          ; A = 00
        inc     de
        ld      (de),a          ; A = 00
        ret

DODEL:  ld      a,(NULFLG)      ; Get null flag status
        or      a               ; Is it zero?
        ld      a,0             ; Zero A - Leave flags
        ld      (NULFLG),a      ; Zero null flag
        jp      nz,ECHDEL       ; Set - Echo it
        dec     b               ; Decrement length
        jp      z,GETLIN        ; Get line again if empty
        call    OUTC            ; Output null character
        db      $3E             ; Skip "DEC B"
ECHDEL: dec     b               ; Count bytes in buffer
        dec     hl              ; Back space buffer
        jp      z,OTKLN         ; No buffer - Try again
        ld      a,(hl)          ; Get deleted byte
        call    OUTC            ; Echo it
        jp      MORINP          ; Get more input

DELCHR: dec     b               ; Count bytes in buffer
        dec     hl              ; Back space buffer
        call    OUTC            ; Output character in A
        jp      nz,MORINP       ; Not end - Get more
OTKLN:  call    OUTC            ; Output character in A
KILIN:  call    PRNTCR          ; Output CRLF
        jp      TTYLIN          ; Get line again

GETLIN: call    MONTST          ; Is it NAS-SYS?
        jp      z,TTYLIN        ; No - Character input
        ld      hl,(CIN)        ; Point to NAS-SYS input table
        ld      a,(hl)          ; Get input mode
        cp      $74             ; Is it "X" mode?
        jp      z,TTYLIN        ; Yes - Teletype line input
        call    INLINE          ; Get a line from NAS-SYS
        jp      DONULL          ; POS(X)=0 and do nulls

TTYLIN: ld      hl,BUFFER       ; Get a line by character
        ld      b,1             ; Set buffer as empty
        xor     a
        ld      (NULFLG),a      ; Clear null flag
MORINP: call    CLOTST          ; Get character and test ^O
        ld      c,a             ; Save character in C
        cp      DEL             ; Delete character?
        jp      z,DODEL         ; Yes - Process it
        ld      a,(NULFLG)      ; Get null flag
        or      a               ; Test null flag status
        jp      z,PROCES        ; Reset - Process character
        ld      a,0             ; Set a null
        call    OUTC            ; Output null
        xor     a               ; Clear A
        ld      (NULFLG),a      ; Reset null flag
PROCES: ld      a,c             ; Get character
        cp      CTRLG           ; Bell?
        jp      z,PUTCTL        ; Yes - Save it
        cp      CTRLC           ; Is it control "C"?
        call    z,PRNTCR        ; Yes - Output CRLF
        scf                     ; Flag break
        ret     z               ; Return if control "C"
        cp      CR              ; Is it enter?
        jp      z,ENDINP        ; Yes - Terminate input
        cp      CTRLU           ; Is it control "U"?
        jp      z,KILIN         ; Yes - Get another line
        cp      "@"             ; Is it "kill line"?
        jp      z,OTKLN         ; Yes - Kill line
        cp      "_"             ; Is it delete?
        jp      z,DELCHR        ; Yes - Delete character
        cp      BKSP            ; Is it backspace?
        jp      z,DELCHR        ; Yes - Delete character
        cp      CTRLR           ; Is it control "R"?
        jp      nz,PUTBUF       ; No - Put in buffer
        push    bc              ; Save buffer length
        push    de              ; Save DE
        push    hl              ; Save buffer address
        ld      (hl),0          ; Mark end of buffer
        call    OUTNCR          ; Output and do CRLF
        ld      hl,BUFFER       ; Point to buffer start
        call    PRS             ; Output buffer
        pop     hl              ; Restore buffer address
        pop     de              ; Restore DE
        pop     bc              ; Restore buffer length
        jp      MORINP          ; Get another character

PUTBUF: cp      " "             ; Is it a control code?
        jp      c,MORINP        ; Yes - Ignore
PUTCTL: ld      a,b             ; Get number of bytes in buffer
        cp      72+1            ; Test for line overflow
        ld      a,CTRLG         ; Set a bell
        jp      nc,OUTNBS       ; Ring bell if buffer full
        ld      a,c             ; Get character
        ld      (hl),c          ; Save in buffer
        ld      (LSTBIN),a      ; Save last input byte
        inc     hl              ; Move up buffer
        inc     b               ; Increment length
OUTIT:  call    OUTC            ; Output the character entered
        jp      MORINP          ; Get another character

OUTNBS: call    OUTC            ; Output bell and back over it
        ld      a,BKSP          ; Set back space
        jp      OUTIT           ; Output it and get more

CPDEHL: ld      a,h             ; Get H
        sub     d               ; Compare with D
        ret     nz              ; Different - Exit
        ld      a,l             ; Get L
        sub     e               ; Compare with E
        ret                     ; Return status

CHKSYN: ld      a,(hl)          ; Check syntax of character
        ex      (sp),hl         ; Address of test byte
        cp      (hl)            ; Same as in code string?
        inc     hl              ; Return address
        ex      (sp),hl         ; Put it back
        jp      z,GETCHR        ; Yes - Get next character
        jp      SNERR           ; Different - ?SN Error

OUTC:   push    af              ; Save character
        ld      a,(CTLOFG)      ; Get control "O" flag
        or      a               ; Is it set?
        jp      nz,POPAF        ; Yes - don't output
        pop     af              ; Restore character
        push    bc              ; Save buffer length
        push    af              ; Save character
        cp      " "             ; Is it a control code?
        jp      c,DINPOS        ; Yes - Don't INC POS(X)
        ld      a,(LWIDTH)      ; Get line width
        ld      b,a             ; To B
        ld      a,(CURPOS)      ; Get cursor position
        inc     b               ; Width 255?
        jp      z,INCLEN        ; Yes - No width limit
        dec     b               ; Restore width
        cp      b               ; At end of line?
        call    z,PRNTCR        ; Yes - output CRLF
INCLEN: inc     a               ; Move on one character
        ld      (CURPOS),a      ; Save new position
DINPOS: pop     af              ; Restore character
        pop     bc              ; Restore buffer length
        push    af              ; << This sequence >>
        pop     af              ; << is not needed >>
        push    af              ; Save character
        push    bc              ; Save buffer length
        ld      c,a             ; Character to C
        call    CONMON          ; Send it
        pop     bc              ; Restore buffer length
        pop     af              ; Restore character
        ret

CLOTST: call    GETINP          ; Get input character
        and     %01111111       ; Strip bit 7
        cp      CTRLO           ; Is it control "O"?
        ret     nz              ; No don't flip flag
        ld      a,(CTLOFG)      ; Get flag
        cpl                     ; Flip it
        ld      (CTLOFG),a      ; Put it back
        xor     a               ; Null character
        ret

LIST:   call    ATOH            ; ASCII number to DE
        ret     nz              ; Return if anything extra
        pop     bc              ; Rubbish - Not needed
        call    SRCHLN          ; Search for line number in DE
        push    bc              ; Save address of line
        call    SETLIN          ; Set up lines counter
LISTLP: pop     hl              ; Restore address of line
        ld      c,(hl)          ; Get LSB of next line
        inc     hl
        ld      b,(hl)          ; Get MSB of next line
        inc     hl
        ld      a,b             ; BC = 0 (End of program)?
        or      c
        jp      z,PRNTOK        ; Yes - Go to command mode
        call    COUNT           ; Count lines
        call    TSTBRK          ; Test for break key
        push    bc              ; Save address of next line
        call    PRNTCR          ; Output CRLF
        ld      e,(hl)          ; Get LSB of line number
        inc     hl
        ld      d,(hl)          ; Get MSB of line number
        inc     hl
        push    hl              ; Save address of line start
        ex      de,hl           ; Line number to HL
        call    PRNTHL          ; Output line number in decimal
        ld      a," "           ; Space after line number
        pop     hl              ; Restore start of line address
LSTLP2: call    OUTC            ; Output character in A
LSTLP3: ld      a,(hl)          ; Get next byte in line
        or      a               ; End of line?
        inc     hl              ; To next byte in line
        jp      z,LISTLP        ; Yes - get next line
        jp      p,LSTLP2        ; No token - output it
        sub     ZEND-1          ; Find and output word
        ld      c,a             ; Token offset+1 to C
        ld      de,WORDS        ; Reserved word list
FNDTOK: ld      a,(de)          ; Get character in list
        inc     de              ; Move on to next
        or      a               ; Is it start of word?
        jp      p,FNDTOK        ; No - Keep looking for word
        dec     c               ; Count words
        jp      nz,FNDTOK       ; Not there - keep looking
OUTWRD: and     %01111111       ; Strip bit 7
        call    OUTC            ; Output first character
        ld      a,(de)          ; Get next character
        inc     de              ; Move on to next
        or      a               ; Is it end of word?
        jp      p,OUTWRD        ; No - output the rest
        jp      LSTLP3          ; Next byte in line

SETLIN: push    hl              ; Set up LINES counter
        ld      hl,(LINESN)     ; Get LINES number
        ld      (LINESC),hl     ; Save in LINES counter
        pop     hl
        ret

LDNMI1: ld      hl,BREAK        ; Break routine
        ld      (NMI),hl        ; NMI forces break
        jp      PRNTOK          ; Go to command mode

        db      $FE            ; <<< NO REFERENCE TO HERE >>>

COUNT:  push    hl              ; Save code string address
        push    de
        ld      hl,(LINESC)     ; Get LINES counter
        ld      de,-1
        adc     hl,de           ; Decrement
        ld      (LINESC),hl     ; Put it back
        pop     de
        pop     hl              ; Restore code string address
        ret     p               ; Return if more lines to go
        push    hl              ; Save code string address
        ld      hl,(LINESN)     ; Get LINES number
        ld      (LINESC),hl     ; Reset LINES counter
        ld      a,(NMIFLG)      ; Break by NMI?
        or      a
        jp      nz,ARETN        ; Yes - "RETN"
        call    GETINP          ; Get input character
        cp      CTRLC           ; Is it control "C"?
        jp      z,RSLNBK        ; Yes - Reset LINES an break
        pop     hl              ; Restore code string address
        jp      COUNT           ; Keep on counting

RSLNBK: ld      hl,(LINESN)     ; Get LINES number
        ld      (LINESC),hl     ; Reset LINES counter
        jp      BRKRET          ; Go and output "Break"

ffor:   ld      a,$64           ; Flag "FOR" assignment
        ld      (FORFLG),a      ; Save "FOR" flag
        call    LET             ; Set up initial index
        pop     bc              ; Drop RETurn address
        push    hl              ; Save code string address
        call    DATA            ; Get next statement address
        ld      (LOOPST),hl     ; Save it for start of lo6p
        ld      hl,2            ; Offset for "FOR" block
        add     hl,sp           ; Point to it
FORSLP: call    LOKFOR          ; Look for existing "FOR" block
        pop     de              ; Get code string address
        jp      nz,FORFND       ; No nesting found
        add     hl,bc           ; Move into "FOR" block
        push    de              ; Save code string address
        dec     hl
        ld      d,(hl)          ; Get MSB of loop statement
        dec     hl
        ld      e,(hl)          ; Get LSB of loop statement
        inc     hl
        inc     hl
        push    hl              ; Save block address
        ld      hl,(LOOPST)     ; Get address of loop statement
        call    CPDEHL          ; Compare the FOR loops
        pop     hl              ; Restore block address
        jp      nz,FORSLP       ; Different FORs - Find another
        pop     de              ; Restore code string address
        ld      sp,hl           ; Remove all nested loops

FORFND: ex      de,hl           ; Code string address to HL
        ld      c,8
        call    CHKSTK          ; Check for 8 levels of stack
        push    hl              ; Save code string address
        ld      hl,(LOOPST)     ; Get first statement of loop
        ex      (sp),hl         ; Save and restore code string
        push    hl              ; Re-save code string address
        ld      hl,(LINEAT)     ; Get current line number
        ex      (sp),hl         ; Save and restore code string
        call    TSTNUM          ; Make sure it's a number
        call    CHKSYN          ; Make sure "TO" is next
        db      ZTO             ; "TO" token
        call    GETNUM          ; Get "TO" expression value
        push    hl              ; Save code string address
        call    BCDEFP          ; Move "TO" value to BCDE
        pop     hl              ; Restore code string address
        push    bc              ; Save "TO" value in block
        push    de
        ld      bc,$8100        ; BCDE - 1 (default STEP)
        ld      d,c             ; C=0
        ld      e,d             ; D=0
        ld      a,(hl)          ; Get next byte in code string
        cp      ZSTEP           ; See if "STEP" is stated
        ld      a,1             ; Sign of step = 1
        jp      nz,SAVSTP       ; No STEP given - Default to 1
        call    GETCHR          ; Jump over "STEP" token
        call    GETNUM          ; Get step value
        push    hl              ; Save code string address
        call    BCDEFP          ; Move STEP to BCDE
        call    TSTSGN          ; Test sign of FPREG
        pop     hl              ; Restore code string address
SAVSTP: push    bc              ; Save the STEP value in block
        push    de
        push    af              ; Save sign of STEP
        inc     sp              ; Don't save flags
        push    hl              ; Save code string address
        ld      hl,(BRKLIN)     ; Get address of index variable
        ex      (sp),hl         ; Save and restore code string
PUTFID: ld      b,ZFOR          ; "FOR" block marker
        push    bc              ; Save it
        inc     sp              ; Don't save C

RUNCNT: call    CHKBRK          ; Execution driver - Test break
        or      a               ; Break key hit?
        call    nz,STALL        ; Yes - Pause for a key
        ld      (BRKLIN),hl     ; Save code address for break
        ld      a,(hl)          ; Get next byte in code string
        cp      ":"             ; Multi statement line?
        jp      z,EXCUTE        ; Yes - Execute it
        or      a               ; End of line?
        jp      nz,SNERR        ; No - Syntax error
        inc     hl              ; Point to address of next line
        ld      a,(hl)          ; Get LSB of line pointer
        inc     hl
        or      (hl)            ; Is it zero (End of prog)?
        jp      z,ENDPRG        ; Yes - Terminate execution
        inc     hl              ; Point to line number
        ld      e,(hl)          ; Get LSB of line number
        inc     hl
        ld      d,(hl)          ; Get MSB of line number
        ex      de,hl           ; Line number to HL
        ld      (LINEAT),hl     ; Save as current line number
        ex      de,hl           ; Line number back to DE
EXCUTE: call    GETCHR          ; Get key word
        ld      de,RUNCNT       ; Where to RETurn to
        push    de              ; Save for RETurn
IFJMP:  ret     z               ; Go to RUNCNT if end of STMT
ONJMP:  sub     ZEND            ; Is it a token?
        jp      c,LET           ; No - try to assign it
        cp      ZNEW+1-ZEND     ; END to NEW ?
        jp      nc,SNERR        ; Not a key word - ?SN Error
        rlca                    ; Double it
        ld      c,a             ; BC = Offset into table
        ld      b,0
        ex      de,hl           ; Save code string address
        ld      hl,WORDTB       ; Keyword address table
        add     hl,bc           ; Point to routine address
        ld      c,(hl)          ; Get LSB of routine address
        inc     hl
        ld      b,(hl)          ; Get MSB of routine address
        push    bc              ; Save routine address
        ex      de,hl           ; Restore code string address

GETCHR: inc     hl              ; Point to next character
        ld      a,(hl)          ; Get next code string byte
        cp      ":"             ; Z if ":"
        ret     nc              ; NC if > "9"
        cp      " "
        jp      z,GETCHR        ; Skip over spaces
        cp      "0"
        ccf                     ; NC if < "0"
        inc     a               ; Test for zero - Leave carry
        dec     a               ; Z if Null
        ret

RESTOR: ex      de,hl           ; Save code string address
        ld      hl,(BASTXT)     ; Point to start of program
        jp      z,RESTNL        ; Just RESTORE - reset pointer
        ex      de,hl           ; Restore code string address
        call    ATOH            ; Get line number to DE
        push    hl              ; Save code string address
        call    SRCHLN          ; Search for line number in DE
        ld      h,b             ; HL = Address of line
        ld      l,c
        pop     de              ; Restore code string address
        jp      nc,ULERR        ; ?UL Error if not found
RESTNL: dec     hl              ; Byte before DATA statement
UPDATA: ld      (NXTDAT),hl     ; Update DATA pointer
        ex      de,hl           ; Restore code string address
        ret

TSTBRK: call    CHKBRK          ; Test for interrupts
        or      a
        ret     z               ; Return if no key pressed
STALL:  call    CLOTST          ; Get input and test for ^O
        cp      CTRLS           ; Is it control "S"
        call    z,CLOTST        ; Yes - Get another character
        cp      CTRLC           ; Return if not control "C"
STOP:   ret     nz              ; Exit if anything else
        db      $F6            ; Flag "STOP"
fpend:  ret     nz              ; Exit if anything else
        ld      (BRKLIN),hl     ; Save point of break
        db      $21             ; Skip "OR 11111111B"
INPBRK: or      %11111111       ; Flag "Break" wanted
        pop     bc              ; Return not needed and more
ENDPRG: ld      hl,(LINEAT)     ; Get current line number
        push    af              ; Save STOP / END status
        ld      a,l             ; Is it direct break?
        and     h
        inc     a               ; Line is -1 if direct break
        jp      z,NOLIN         ; Yes - No line number
        ld      (ERRLIN),hl     ; Save line of break
        ld      hl,(BRKLIN)     ; Get point of break
        ld      (CONTAD),hl     ; Save point to CONTinue
NOLIN:  xor     a
        ld      (CTLOFG),a      ; Enable output
        call    STTLIN          ; Start a new line
        pop     af              ; Restore STOP / END status
        ld      hl,BRKMSG       ; "Break" message
        jp      nz,ERRIN        ; "in line" wanted?
        jp      PRNTOK          ; Go to command mode

CONT:   ld      hl,(CONTAD)     ; Get CONTinue address
        ld      a,h             ; Is it zero?
        or      l
        ld      e,CN            ; ?CN Error
        jp      z,ERROR         ; Yes - output "?CN Error"
        ex      de,hl           ; Save code string address
        ld      hl,(ERRLIN)     ; Get line of last break
        ld      (LINEAT),hl     ; Set up current line number
        ex      de,hl           ; Restore code string address
        ret                     ; CONTinue where left off

NULL:   call    GETINT          ; Get integer 0-255
        ret     nz              ; Return if bad value
        ld      (NULLS),a       ; Set nulls number
        ret

ARRLD1: ld      b,-1            ; Flag array load
ARRSV1: call    GETCHR          ; Skip "*"
        ld      a,b             ; CLOAD* or CSAVE*
        ld      (BRKLIN),a      ; Save it
        ld      a,1             ; It's an array
        ld      (FORFLG),a      ; Flag array name
        call    GETVAR          ; Get address of array name
        push    hl              ; Save code string address
        ld      (FORFLG),a      ; Clear flag
        ld      h,b             ; Address of array to HL
        ld      l,c
        dec     bc              ; Back space
        dec     bc              ;  to point
        dec     bc              ;  to the
        dec     bc              ; array name
        ld      a,(BRKLIN)      ; CLOAD* or CSAVE* ?
        or      a
        push    af              ; Save CLOAD* / CSAVE* status
        ex      de,hl           ; Array data length
        add     hl,de           ; End of data
        ex      de,hl           ; To DE
        ld      c,(hl)          ; Get dimension bytes
        ld      b,0
        add     hl,bc           ; 2 Bytes each dimension
        add     hl,bc
        inc     hl              ; Over number of dimensions
        push    hl              ; Address of array data
        push    de              ; End of array data
        push    bc              ; Number of dimensions
        ld      a,(BRKLIN)      ; CLOAD* or CSAVE* ?
        cp      -1
        call    z,CASFF         ; CLOAD* - Cassette on
        ld      a,(BRKLIN)      ; CLOAD* or CSAVE* ?
        cp      -1
        call    nz,CASFFW       ; CSAVE* - Cassette on and wait
        nop
        nop
        nop
        ld      hl,0
        ld      (CHKSUM),hl     ; Zero check sum
        pop     bc              ; Number of dimensions
        pop     de              ; End of array data
        pop     hl              ; Address of array data
        ld      b,%11010010     ; Header byte
        jp      JPLDSV          ; CSAVE-SNDHDR , CLOAD-GETHDR

SNDHDR: ld      a,b             ; Get header byte
        call    WUART2          ; Send 2 bytes to UART
        call    WUART2          ; Send 2 bytes to UART
        jp      SNDARY          ; Send array data

GETHDR: ld      c,4             ; 4 Bytes to check
HDRLP:  call    RUART           ; Read byte from UART
        cp      b               ; Same as header?
        jp      nz,GETHDR       ; No - Wait for another
        dec     c               ; Count bytes
        jp      nz,HDRLP        ; More needed
SNDARY: call    TSTNUM          ; Check it's a numerical array
ARYLP:  call    CPDEHL          ; All array data done
        jp      z,SUMOFF        ; Yes - Do check sum
        pop     af              ; CLOAD* or CSAVE* ?
        push    af              ; Re-save flags
        ld      a,(hl)          ; Get byte
        call    p,WUART         ; CSAVE* - Write byte
        call    m,RUART         ; CLOAD* - Read byte
        ld      (hl),a          ; Save byte in case of CLOAD*
        call    ACCSUM          ; Accumulate check sum
        inc     hl              ; Next byte
        jp      ARYLP           ; Repeat

SUMOFF: call    DOSUM           ; Do check sum
        call    CASFF           ; Cassette off
        pop     af              ; Not needed any more
        pop     hl              ; Restore code string address
        ret

ACCSUM: push    hl              ; Save address in array
        ld      hl,(CHKSUM)     ; Get check sum
        ld      b,0             ; BC - Value of byte
        ld      c,a
        add     hl,bc           ; Add byte to check sum
        ld      (CHKSUM),hl     ; Re-save check sum
        pop     hl              ; Restore address in array
        ret

DOSUM:  ld      a,(BRKLIN)      ; CLOAD* or CSAVE* ?
        or      a
        jp      m,CHSUMS        ; CLOAD* - Check if sums match
        ld      a,(CHKSUM)      ; Get LSB of check sum
        call    WUART           ; Write to UART
        ld      a,(CHKSUM+1)    ; Get MSB of check sum
        jp      WUART           ; Write to UART and return

CHSUMS: call    RUART           ; Read LSB of check sum
        push    af              ; Save it
        call    RUART           ; Read MSB of check sum
        pop     bc              ; LSB to B
        ld      e,b             ; LSB to E
        ld      d,a             ; MSB to D
        ld      hl,(CHKSUM)     ; Get accumulated check sum
        call    CPDEHL          ; Are they the same?
        ret     z               ; Yes - End CLOAD*
        call    CASFF           ; Cassette off
        jp      OUTBAD          ; Different - Output "Bad"

CHKLTR: ld      a,(hl)          ; Get byte
        cp      "A"             ; < "A" ?
        ret     c               ; Carry set if not letter
        cp      "Z"+1           ; > "Z" ?
        ccf
        ret                     ; Carry set if not letter

FPSINT: call    GETCHR          ; Get next character
POSINT: call    GETNUM          ; Get integer 0 to 32767
DEPINT: call    TSTSGN          ; Test sign of FPREG
        jp      m,FCERR         ; Negative - ?FC Error
DEINT:  ld      a,(FPEXP)       ; Get integer value to DE
        cp      $80+16          ; Exponent in range (16 bits)?
        jp      c,FPINT         ; Yes - convert it
        ld      bc,$9080        ; BCDE = -32768
        ld      de,$00
        push    hl              ; Save code string address
        call    CMPNUM          ; Compare FPREG with BCDE
        pop     hl              ; Restore code string address
        ld      d,c             ; MSB to D
        ret     z               ; Return if in range
FCERR:  ld      e,FC            ; ?FC Error
        jp      ERROR           ; Output error-

ATOH:   dec     hl              ; ASCII number to DE binary
GETLN:  ld      de,0            ; Get number to DE
GTLNLP: call    GETCHR          ; Get next character
        ret     nc              ; Exit if not a digit
        push    hl              ; Save code string address
        push    af              ; Save digit
        ld      hl,65529/10     ; Largest number 65529
        call    CPDEHL          ; Number in range?
        jp      c,SNERR         ; No - ?SN Error
        ld      h,d             ; HL = Number
        ld      l,e
        add     hl,de           ; Times 2
        add     hl,hl           ; Times 4
        add     hl,de           ; Times 5
        add     hl,hl           ; Times 10
        pop     af              ; Restore digit
        sub     "0"             ; Make it 0 to 9
        ld      e,a             ; DE = Value of digit
        ld      d,0
        add     hl,de           ; Add to number
        ex      de,hl           ; Number to DE
        pop     hl              ; Restore code string address
        jp      GTLNLP          ; Go to next character

CLEAR:  jp      z,INTVAR        ; Just "CLEAR" Keep parameters
        call    POSINT          ; Get integer 0 to 32767 to DE
        dec     hl              ; Cancel increment
        call    GETCHR          ; Get next character
        push    hl              ; Save code string address
        ld      hl,(LSTRAM)     ; Get end of RAM
        jp      z,STORED        ; No value given - Use stored
        pop     hl              ; Restore code string address
        call    CHKSYN          ; Check for comma
        db      ","
        push    de              ; Save number
        call    POSINT          ; Get integer 0 to 32767
        dec     hl              ; Cancel increment
        call    GETCHR          ; Get next character
        jp      nz,SNERR        ; ?SN Error if more on line
        ex      (sp),hl         ; Save code string address
        ex      de,hl           ; Number to DE
STORED: ld      a,l             ; Get LSB of new RAM top
        sub     e               ; Subtract LSB of string space
        ld      e,a             ; Save LSB
        ld      a,h             ; Get MSB of new RAM top
        sbc     a,d             ; Subtract MSB of string space
        ld      d,a             ; Save MSB
        jp      c,OMERR         ; ?OM Error if not enough mem
        push    hl              ; Save RAM top
        ld      hl,(PROGND)     ; Get program end
        ld      bc,40           ; 40 Bytes minimum working RAM
        add     hl,bc           ; Get lowest address
        call    CPDEHL          ; Enough memory?
        jp      nc,OMERR        ; No - ?OM Error
        ex      de,hl           ; RAM top to HL
        ld      (STRSPC),hl     ; Set new string space
        pop     hl              ; End of memory to use
        ld      (LSTRAM),hl     ; Set new top of RAM
        pop     hl              ; Restore code string address
        jp      INTVAR          ; Initialise variables

RUN:    jp      z,RUNFST        ; RUN from start if just RUN
        call    INTVAR          ; Initialise variables
        ld      bc,RUNCNT       ; Execution driver loop
        jp      RUNLIN          ; RUN from line number

GOSUB:  ld      c,3             ; 3 Levels of stack needed
        call    CHKSTK          ; Check for 3 levels of stack
        pop     bc              ; Get return address
        push    hl              ; Save code string for RETURN
        push    hl              ; And for GOSUB routine
        ld      hl,(LINEAT)     ; Get current line
        ex      (sp),hl         ; Into stack - Code string out
        ld      a,ZGOSUB        ; "GOSUB" token
        push    af              ; Save token
        inc     sp              ; Don't save flags

RUNLIN: push    bc              ; Save return address
GOTO:   call    ATOH            ; ASCII number to DE binary
        call    REM             ; Get end of line
        push    hl              ; Save end of line
        ld      hl,(LINEAT)     ; Get current line
        call    CPDEHL          ; Line after current?
        pop     hl              ; Restore end of line
        inc     hl              ; Start of next line
        call    c,SRCHLP        ; Line is after current line
        call    nc,SRCHLN       ; Line is before current line
        ld      h,b             ; Set up code string address
        ld      l,c
        dec     hl              ; Incremented after
        ret     c               ; Line found
ULERR:  ld      e,UL            ; ?UL Error
        jp      ERROR           ; Output error message

RETURN: ret     nz              ; Return if not just RETURN
        ld      d,-1            ; Flag "GOSUB" search
        call    BAKSTK          ; Look "GOSUB" block
        ld      sp,hl           ; Kill all FORs in subroutine
        cp      ZGOSUB          ; Test for "GOSUB" token
        ld      e,RG            ; ?RG Error
        jp      nz,ERROR        ; Error if no "GOSUB" found
        pop     hl              ; Get RETURN line number
        ld      (LINEAT),hl     ; Save as current
        inc     hl              ; Was it from direct statement?
        ld      a,h
        or      l               ; Return to line
        jp      nz,RETLIN       ; No - Return to line
        ld      a,(LSTBIN)      ; Any INPUT in subroutine?
        or      a               ; If so buffer is corrupted
        jp      nz,POPNOK       ; Yes - Go to command mode
RETLIN: ld      hl,RUNCNT       ; Execution driver loop
        ex      (sp),hl         ; Into stack - Code string out
        db      $3E             ; Skip "POP HL"
NXTDTA: pop     hl              ; Restore code string address

DATA:   db      $01,$3A         ; ":" End of statement
REM:    ld      c,0             ; 00  End of statement
        ld      b,0
NXTSTL: ld      a,c             ; Statement and byte
        ld      c,b
        ld      b,a             ; Statement end byte
NXTSTT: ld      a,(hl)          ; Get byte
        or      a               ; End of line?
        ret     z               ; Yes - Exit
        cp      b               ; End of statement?
        ret     z               ; Yes - Exit
        inc     hl              ; Next byte
        cp      '"'             ; Literal string?
        jp      z,NXTSTL        ; Yes - Look for another '"'
        jp      NXTSTT          ; Keep looking

LET:    call    GETVAR          ; Get variable name
        call    CHKSYN          ; Make sure "=" follows
        db      ZEQUAL          ; "=" token
        push    de              ; Save address of variable
        ld      a,(TYPE)        ; Get data type
        push    af              ; Save type
        call    EVAL            ; Evaluate expression
        pop     af              ; Restore type
        ex      (sp),hl         ; Save code - Get var addr
        ld      (BRKLIN),hl     ; Save address of variable
        rra                     ; Adjust type
        call    CHKTYP          ; Check types are the same
        jp      z,LETNUM        ; Numeric - Move value
LETSTR: push    hl              ; Save address of string var
        ld      hl,(FPREG)      ; Pointer to string entry
        push    hl              ; Save it on stack
        inc     hl              ; Skip over length
        inc     hl
        ld      e,(hl)          ; LSB of string address
        inc     hl
        ld      d,(hl)          ; MSB of string address
        ld      hl,(BASTXT)     ; Point to start of program
        call    CPDEHL          ; Is string before program?
        jp      nc,CRESTR       ; Yes - Create string entry
        ld      hl,(STRSPC)     ; Point to string space
        call    CPDEHL          ; Is string literal in program?
        pop     de              ; Restore address of string
        jp      nc,MVSTPT       ; Yes - Set up pointer
        ld      hl,TMPSTR       ; Temporary string pool
        call    CPDEHL          ; Is string in temporary pool?
        jp      nc,MVSTPT       ; No - Set up pointer
        db      $3E             ; Skip "POP DE"
CRESTR: pop     de              ; Restore address of string
        call    BAKTMP          ; Back to last tmp-str entry
        ex      de,hl           ; Address of string entry
        call    SAVSTR          ; Save string in string area
MVSTPT: call    BAKTMP          ; Back to last tmp-str entry
        pop     hl              ; Get string pointer
        call    DETHL4          ; Move string pointer to var
        pop     hl              ; Restore code string address
        ret

LETNUM: push    hl              ; Save address of variable
        call    FPTHL           ; Move value to variable
        pop     de              ; Restore address of variable
        pop     hl              ; Restore code string address
        ret

ON:     call    GETINT          ; Get integer 0-255
        ld      a,(hl)          ; Get "GOTO" or "GOSUB" token
        ld      b,a             ; Save in B
        cp      ZGOSUB          ; "GOSUB" token?
        jp      z,ONGO          ; Yes - Find line number
        call    CHKSYN          ; Make sure it's "GOTO"
        db      ZGOTO           ; "GOTO" token
        dec     hl              ; Cancel increment
ONGO:   ld      c,e             ; Integer of branch value
ONGOLP: dec     c               ; Count branches
        ld      a,b             ; Get "GOTO" or "GOSUB" token
        jp      z,ONJMP         ; Go to that line if right one
        call    GETLN           ; Get line number to DE
        cp      ","             ; Another line number?
        ret     nz              ; No - Drop through
        jp      ONGOLP          ; Yes - loop

fif:    call    EVAL            ; Evaluate expression
        ld      a,(hl)          ; Get token
        cp      ZGOTO           ; "GOTO" token?
        jp      z,IFGO          ; Yes - Get line
        call    CHKSYN          ; Make sure it's "THEN"
        db      ZTHEN           ; "THEN" token
        dec     hl              ; Cancel increment
IFGO:   call    TSTNUM          ; Make sure it's numeric
        call    TSTSGN          ; Test state of expression
        jp      z,REM           ; False - Drop through
        call    GETCHR          ; Get next character
        jp      c,GOTO          ; Number - GOTO that line
        jp      IFJMP           ; Otherwise do statement

MRPRNT: dec     hl              ; DEC 'cos GETCHR INCs
        call    GETCHR          ; Get next character
PRINT:  jp      z,PRNTCR        ; CRLF if just PRINT
PRNTLP: ret     z               ; End of list - Exit
        cp      ZTAB            ; "TAB(" token?
        jp      z,DOTAB         ; Yes - Do TAB routine
        cp      ZSPC            ; "SPC(" token?
        jp      z,DOTAB         ; Yes - Do SPC routine
        push    hl              ; Save code string address
        cp      ","             ; Comma?
        jp      z,DOCOM         ; Yes - Move to next zone
        cp      ";"             ; Semi-colon?
        jp      z,NEXITM        ; Do semi-colon routine
        pop     bc              ; Code string address to BC
        call    EVAL            ; Evaluate expression
        push    hl              ; Save code string address
        ld      a,(TYPE)        ; Get variable type
        or      a               ; Is it a string variable?
        jp      nz,PRNTST       ; Yes - Output string contents
        call    NUMASC          ; Convert number to text
        call    CRTST           ; Create temporary string
        ld      (hl)," "        ; Followed by a space
        ld      hl,(FPREG)      ; Get length of output
        inc     (hl)            ; Plus 1 for the space
        ld      hl,(FPREG)      ; < Not needed >
        ld      a,(LWIDTH)      ; Get width of line
        ld      b,a             ; To B
        inc     b               ; Width 255 (No limit)?
        jp      z,PRNTNB        ; Yes - Output number string
        inc     b               ; Adjust it
        ld      a,(CURPOS)      ; Get cursor position
        add     a,(hl)          ; Add length of string
        dec     a               ; Adjust it
        cp      b               ; Will output fit on this line?
        call    nc,PRNTCR       ; No - CRLF first
PRNTNB: call    PRS1            ; Output string at (HL)
        xor     a               ; Skip CALL by setting "Z" flag
PRNTST: call    nz,PRS1         ; Output string at (HL)
        pop     hl              ; Restore code string address
        jp      MRPRNT          ; See if more to PRINT

STTLIN: ld      a,(CURPOS)      ; Make sure on new line
        or      a               ; Already at start?
        ret     z               ; Yes - Do nothing
        jp      PRNTCR          ; Start a new line

ENDINP: ld      (hl),0          ; Mark end of buffer
        ld      hl,BUFFER-1     ; Point to buffer
PRNTCR: ld      a,CR            ; Load a CR
        call    OUTC            ; Output character
DONULL: xor     a               ; Set to position 0
        ld      (CURPOS),a      ; Store it
        ld      a,(NULLS)       ; Get number of nulls
NULLP:  dec     a               ; Count them
        ret     z               ; Return if done
        push    af              ; Save count
        xor     a               ; Load a null
        call    OUTC            ; Output it
        pop     af              ; Restore count
        jp      NULLP           ; Keep counting

DOCOM:  ld      a,(COMMAN)      ; Get comma width
        ld      b,a             ; Save in B
        ld      a,(CURPOS)      ; Get current position
        cp      b               ; Within the limit?
        call    nc,PRNTCR       ; No - output CRLF
        jp      nc,NEXITM       ; Get next item
ZONELP: sub     14              ; Next zone of 14 characters
        jp      nc,ZONELP       ; Repeat if more zones
        cpl                     ; Number of spaces to output
        jp      ASPCS           ; Output them

DOTAB:  push    af              ; Save token
        call    FNDNUM          ; Evaluate expression
        call    CHKSYN          ; Make sure ")" follows
        db      ")"
        dec     hl              ; Back space on to ")"
        pop     af              ; Restore token
        sub     ZSPC            ; Was it "SPC(" ?
        push    hl              ; Save code string address
        jp      z,DOSPC         ; Yes - Do "E" spaces
        ld      a,(CURPOS)      ; Get current position
DOSPC:  cpl                     ; Number of spaces to print to
        add     a,e             ; Total number to print
        jp      nc,NEXITM       ; TAB < Current POS(X)
ASPCS:  inc     a               ; Output A spaces
        ld      b,a             ; Save number to print
        ld      a," "           ; Space
SPCLP:  call    OUTC            ; Output character in A
        dec     b               ; Count them
        jp      nz,SPCLP        ; Repeat if more
NEXITM: pop     hl              ; Restore code string address
        call    GETCHR          ; Get next character
        jp      PRNTLP          ; More to print

REDO:   db      "?Redo from start",CR,LF,0

BADINP: ld      a,(READFG)      ; READ or INPUT?
        or      a
        jp      nz,DATSNR       ; READ - ?SN Error
        pop     bc              ; Throw away code string addr
        ld      hl,REDO         ; "Redo from start" message
        call    PRS             ; Output string
        jp      DOAGN           ; Do last INPUT again

INPUT:  call    IDTEST          ; Test for illegal direct
        ld      a,(hl)          ; Get character after "INPUT"
        cp      '"'             ; Is there a prompt string?
        ld      a,0             ; Clear A and leave flags
        ld      (CTLOFG),a      ; Enable output
        jp      nz,NOPMPT       ; No prompt - get input
        call    QTSTR           ; Get string terminated by '"'
        call    CHKSYN          ; Check for ";" after prompt
        db      ";"
        push    hl              ; Save code string address
        call    PRS1            ; Output prompt string
        db      $3E             ; Skip "PUSH HL"
NOPMPT: push    hl              ; Save code string address
        call    PROMPT          ; Get input with "? " prompt
        pop     bc              ; Restore code string address
        jp      c,INPBRK        ; Break pressed - Exit
        inc     hl              ; Next byte
        ld      a,(hl)          ; Get it
        or      a               ; End of line?
        dec     hl              ; Back again
        push    bc              ; Re-save code string address
        jp      z,NXTDTA        ; Yes - Find next DATA stmt
        ld      (hl),","        ; Store comma as separator
        jp      NXTITM          ; Get next item

READ:   push    hl              ; Save code string address
        ld      hl,(NXTDAT)     ; Next DATA statement
        db      $F6            ; Flag "READ"
NXTITM: xor     a               ; Flag "INPUT"
        ld      (READFG),a      ; Save "READ"/"INPUT" flag
        ex      (sp),hl         ; Get code str' , Save pointer
        jp      GTVLUS          ; Get values

NEDMOR: call    CHKSYN          ; Check for comma between items
        db      ","
GTVLUS: call    GETVAR          ; Get variable name
        ex      (sp),hl         ; Save code str" , Get pointer
        push    de              ; Save variable address
        ld      a,(hl)          ; Get next "INPUT"/"DATA" byte
        cp      ","             ; Comma?
        jp      z,ANTVLU        ; Yes - Get another value
        ld      a,(READFG)      ; Is it READ?
        or      a
        jp      nz,FDTLP        ; Yes - Find next DATA stmt
        ld      a,"?"           ; More INPUT needed
        call    OUTC            ; Output character
        call    PROMPT          ; Get INPUT with prompt
        pop     de              ; Variable address
        pop     bc              ; Code string address
        jp      c,INPBRK        ; Break pressed
        inc     hl              ; Point to next DATA byte
        ld      a,(hl)          ; Get byte
        or      a               ; Is it zero (No input) ?
        dec     hl              ; Back space INPUT pointer
        push    bc              ; Save code string address
        jp      z,NXTDTA        ; Find end of buffer
        push    de              ; Save variable address
ANTVLU: ld      a,(TYPE)        ; Check data type
        or      a               ; Is it numeric?
        jp      z,INPBIN        ; Yes - Convert to binary
        call    GETCHR          ; Get next character
        ld      d,a             ; Save input character
        ld      b,a             ; Again
        cp      '"'             ; Start of literal sting?
        jp      z,STRENT        ; Yes - Create string entry
        ld      a,(READFG)      ; "READ" or "INPUT" ?
        or      a
        ld      d,a             ; Save 00 if "INPUT"
        jp      z,ITMSEP        ; "INPUT" - End with 00
        ld      d,":"           ; "DATA" - End with 00 or ":"
ITMSEP: ld      b,","           ; Item separator
        dec     hl              ; Back space for DTSTR
STRENT: call    DTSTR           ; Get string terminated by D
        ex      de,hl           ; String address to DE
        ld      hl,LTSTND       ; Where to go after LETSTR
        ex      (sp),hl         ; Save HL , get input pointer
        push    de              ; Save address of string
        jp      LETSTR          ; Assign string to variable

INPBIN: call    GETCHR          ; Get next character
        call    ASCTFP          ; Convert ASCII to FP number
        ex      (sp),hl         ; Save input ptr, Get var addr
        call    FPTHL           ; Move FPREG to variable
        pop     hl              ; Restore input pointer
LTSTND: dec     hl              ; DEC 'cos GETCHR INCs
        call    GETCHR          ; Get next character
        jp      z,MORDT         ; End of line - More needed?
        cp      ","             ; Another value?
        jp      nz,BADINP       ; No - Bad input
MORDT:  ex      (sp),hl         ; Get code string address
        dec     hl              ; DEC 'cos GETCHR INCs
        call    GETCHR          ; Get next character
        jp      nz,NEDMOR       ; More needed - Get it
        pop     de              ; Restore DATA pointer
        ld      a,(READFG)      ; "READ" or "INPUT" ?
        or      a
        ex      de,hl           ; DATA pointer to HL
        jp      nz,UPDATA       ; Update DATA pointer if "READ"
        push    de              ; Save code string address
        or      (hl)            ; More input given?
        ld      hl,EXTIG        ; "?Extra ignored" message
        call    nz,PRS          ; Output string if extra given
        pop     hl              ; Restore code string address
        ret

EXTIG:  db      "?Extra ignored",CR,LF,0

FDTLP:  call    DATA            ; Get next statement
        or      a               ; End of line?
        jp      nz,FANDT        ; No - See if DATA statement
        inc     hl
        ld      a,(hl)          ; End of program?
        inc     hl
        or      (hl)            ; 00 00 Ends program
        ld      e,OD            ; ?OD Error
        jp      z,ERROR         ; Yes - Out of DATA
        inc     hl
        ld      e,(hl)          ; LSB of line number
        inc     hl
        ld      d,(hl)          ; MSB of line number
        ex      de,hl
        ld      (DATLIN),hl     ; Set line of current DATA item
        ex      de,hl
FANDT:  call    GETCHR          ; Get next character
        cp      ZDATA           ; "DATA" token
        jp      nz,FDTLP        ; No "DATA" - Keep looking
        jp      ANTVLU          ; Found - Convert input

fnext:  ld      de,0            ; In case no index given
NEXT1:  call    nz,GETVAR       ; Get index address
        ld      (BRKLIN),hl     ; Save code string address
        call    BAKSTK          ; Look for "FOR" block
        jp      nz,NFERR        ; No "FOR" - ?NF Error
        ld      sp,hl           ; Clear nested loops
        push    de              ; Save index address
        ld      a,(hl)          ; Get sign of STEP
        inc     hl
        push    af              ; Save sign of STEP
        push    de              ; Save index address
        call    PHLTFP          ; Move index value to FPREG
        ex      (sp),hl         ; Save address of TO value
        push    hl              ; Save address of index
        call    ADDPHL          ; Add STEP to index value
        pop     hl              ; Restore address of index
        call    FPTHL           ; Move value to index variable
        pop     hl              ; Restore address of TO value
        call    LOADFP          ; Move TO value to BCDE
        push    hl              ; Save address of line of FOR
        call    CMPNUM          ; Compare index with TO value
        pop     hl              ; Restore address of line num
        pop     bc              ; Address of sign of STEP
        sub     b               ; Compare with expected sign
        call    LOADFP          ; BC = Loop stmt,DE = Line num
        jp      z,KILFOR        ; Loop finished - Terminate it
        ex      de,hl           ; Loop statement line number
        ld      (LINEAT),hl     ; Set loop line number
        ld      l,c             ; Set code string to loop
        ld      h,b
        jp      PUTFID          ; Put back "FOR" and continue

KILFOR: ld      sp,hl           ; Remove "FOR" block
        ld      hl,(BRKLIN)     ; Code string after "NEXT"
        ld      a,(hl)          ; Get next byte in code string
        cp      ","             ; More NEXTs ?
        jp      nz,RUNCNT       ; No - Do next statement
        call    GETCHR          ; Position to index name
        call    NEXT1           ; Re-enter NEXT routine
; < will not RETurn to here , Exit to RUNCNT or Loop >

GETNUM: call    EVAL            ; Get a numeric expression
TSTNUM: db      $F6            ; Clear carry (numeric)
TSTSTR: scf                     ; Set carry (string)
CHKTYP: ld      a,(TYPE)        ; Check types match
        adc     a,a             ; Expected + actual
        or      a               ; Clear carry , set parity
        ret     pe              ; Even parity - Types match
        jp      TMERR           ; Different types - Error

; <<< NO REFERENCE TO HERE >>>

        call    CHKSYN          ; Make sure "=" follows
        db      ZEQUAL          ; "="
        jp      EVAL            ; Evaluate expression

OPNPAR: call    CHKSYN          ; Make sure "(" follows
        db      "("
EVAL:   dec     hl              ; Evaluate expression & save
        ld      d,0             ; Precedence value
EVAL1:  push    de              ; Save precedence
        ld      c,1
        call    CHKSTK          ; Check for 1 level of stack
        call    OPRND           ; Get next expression value
EVAL2:  ld      (NXTOPR),hl     ; Save address of next operator
EVAL3:  ld      hl,(NXTOPR)     ; Restore address of next opr
        pop     bc              ; Precedence value and operator
        ld      a,b             ; Get precedence value
        cp      $78             ; "AND" or "OR" ?
        call    nc,TSTNUM       ; No - Make sure it's a number
        ld      a,(hl)          ; Get next operator / function
        ld      d,0             ; Clear Last relation
RLTLP:  sub     ZGTR            ; ">" Token
        jp      c,FOPRND        ; + - * / ^ AND OR - Test it
        cp      ZLTH+1-ZGTR     ; < = >
        jp      nc,FOPRND       ; Function - Call it
        cp      ZEQUAL-ZGTR     ; "="
        rla                     ; <- Test for legal
        xor     d               ; <- combinations of < = >
        cp      d               ; <- by combining last token
        ld      d,a             ; <- with current one
        jp      c,SNERR         ; Error if "<<" "==" or ">>"
        ld      (CUROPR),hl     ; Save address of current token
        call    GETCHR          ; Get next character
        jp      RLTLP           ; Treat the two as one

FOPRND: ld      a,d             ; < = > found ?
        or      a
        jp      nz,TSTRED       ; Yes - Test for reduction
        ld      a,(hl)          ; Get operator token
        ld      (CUROPR),hl     ; Save operator address
        sub     ZPLUS           ; Operator or function?
        ret     c               ; Neither - Exit
        cp      ZOR+1-ZPLUS     ; Is it + - * / ^ AND OR ?
        ret     nc              ; No - Exit
        ld      e,a             ; Coded operator
        ld      a,(TYPE)        ; Get data type
        dec     a               ; FF = numeric , 00 = string
        or      e               ; Combine with coded operator
        ld      a,e             ; Get coded operator
        jp      z,CONCAT        ; String concatenation
        rlca                    ; Times 2
        add     a,e             ; Times 3
        ld      e,a             ; To DE (D is 0)
        ld      hl,PRITAB       ; Precedence table
        add     hl,de           ; To the operator concerned
        ld      a,b             ; Last operator precedence
        ld      d,(hl)          ; Get evaluation precedence
        cp      d               ; Compare with eval precedence
        ret     nc              ; Exit if higher precedence
        inc     hl              ; Point to routine address
        call    TSTNUM          ; Make sure it's a number

STKTHS: push    bc              ; Save last precedence & token
        ld      bc,EVAL3        ; Where to go on prec' break
        push    bc              ; Save on stack for return
        ld      b,e             ; Save operator
        ld      c,d             ; Save precedence
        call    STAKFP          ; Move value to stack
        ld      e,b             ; Restore operator
        ld      d,c             ; Restore precedence
        ld      c,(hl)          ; Get LSB of routine address
        inc     hl
        ld      b,(hl)          ; Get MSB of routine address
        inc     hl
        push    bc              ; Save routine address
        ld      hl,(CUROPR)     ; Address of current operator
        jp      EVAL1           ; Loop until prec' break

OPRND:  xor     a               ; Get operand routine
        ld      (TYPE),a        ; Set numeric expected
        call    GETCHR          ; Get next character
        ld      e,MO            ; ?MO Error
        jp      z,ERROR         ; No operand - Error
        jp      c,ASCTFP        ; Number - Get value
        call    CHKLTR          ; See if a letter
        jp      nc,CONVAR       ; Letter - Find variable
        cp      ZPLUS           ; "+" Token ?
        jp      z,OPRND         ; Yes - Look for operand
        cp      "."             ; "." ?
        jp      z,ASCTFP        ; Yes - Create FP number
        cp      ZMINUS          ; "-" Token ?
        jp      z,MINUS         ; Yes - Do minus
        cp      '"'             ; Literal string ?
        jp      z,QTSTR         ; Get string terminated by '"'
        cp      ZNOT            ; "NOT" Token ?
        jp      z,EVNOT         ; Yes - Eval NOT expression
        cp      ZFN             ; "FN" Token ?
        jp      z,DOFN          ; Yes - Do FN routine
        sub     ZSGN            ; Is it a function?
        jp      nc,FNOFST       ; Yes - Evaluate function
EVLPAR: call    OPNPAR          ; Evaluate expression in "()"
        call    CHKSYN          ; Make sure ")" follows
        db      ")"
        ret

MINUS:  ld      d,$7D           ; "-" precedence
        call    EVAL1           ; Evaluate until prec' break
        ld      hl,(NXTOPR)     ; Get next operator address
        push    hl              ; Save next operator address
        call    INVSGN          ; Negate value
RETNUM: call    TSTNUM          ; Make sure it's a number
        pop     hl              ; Restore next operator address
        ret

CONVAR: call    GETVAR          ; Get variable address to DE
FRMEVL: push    hl              ; Save code string address
        ex      de,hl           ; Variable address to HL
        ld      (FPREG),hl      ; Save address of variable
        ld      a,(TYPE)        ; Get type
        or      a               ; Numeric?
        call    z,PHLTFP        ; Yes - Move contents to FPREG
        pop     hl              ; Restore code string address
        ret

FNOFST: ld      b,0             ; Get address of function
        rlca                    ; Double function offset
        ld      c,a             ; BC = Offset in function table
        push    bc              ; Save adjusted token value
        call    GETCHR          ; Get next character
        ld      a,c             ; Get adjusted token value
        cp      2*(ZPOINT-ZSGN) ; Adjusted "POINT" token?
        jp      z,POINTB        ; Yes - Do "POINT" (not POINTB)
        cp      2*(ZLEFT-ZSGN)-1; Adj' LEFT$,RIGHT$ or MID$ ?
        jp      c,FNVAL         ; No - Do function
        call    OPNPAR          ; Evaluate expression  (X,...
        call    CHKSYN          ; Make sure "," follows
        db      ","
        call    TSTSTR          ; Make sure it's a string
        ex      de,hl           ; Save code string address
        ld      hl,(FPREG)      ; Get address of string
        ex      (sp),hl         ; Save address of string
        push    hl              ; Save adjusted token value
        ex      de,hl           ; Restore code string address
        call    GETINT          ; Get integer 0-255
        ex      de,hl           ; Save code string address
        ex      (sp),hl         ; Save integer,HL = adj' token
        jp      GOFUNC          ; Jump to string function

FNVAL:  call    EVLPAR          ; Evaluate expression
        ex      (sp),hl         ; HL = Adjusted token value
        ld      de,RETNUM       ; Return number from function
        push    de              ; Save on stack
GOFUNC: ld      bc,FNCTAB       ; Function routine addresses
        add     hl,bc           ; Point to right address
        ld      c,(hl)          ; Get LSB of address
        inc     hl              ;
        ld      h,(hl)          ; Get MSB of address
        ld      l,c             ; Address to HL
        jp      (hl)            ; Jump to function

SGNEXP: dec     d               ; Dee to flag negative exponent
        cp      ZMINUS          ; "-" token ?
        ret     z               ; Yes - Return
        cp      "-"             ; "-" ASCII ?
        ret     z               ; Yes - Return
        inc     d               ; Inc to flag positive exponent
        cp      "+"             ; "+" ASCII ?
        ret     z               ; Yes - Return
        cp      ZPLUS           ; "+" token ?
        ret     z               ; Yes - Return
        dec     hl              ; DEC 'cos GETCHR INCs
        ret                     ; Return "NZ"

POR:    db      $F6            ; Flag "OR"
PAND:   xor     a               ; Flag "AND"
        push    af              ; Save "AND" / "OR" flag
        call    TSTNUM          ; Make sure it's a number
        call    DEINT           ; Get integer -32768 to 32767
        pop     af              ; Restore "AND" / "OR" flag
        ex      de,hl           ; <- Get last
        pop     bc              ; <-  value
        ex      (sp),hl         ; <-  from
        ex      de,hl           ; <-  stack
        call    FPBCDE          ; Move last value to FPREG
        push    af              ; Save "AND" / "OR" flag
        call    DEINT           ; Get integer -32768 to 32767
        pop     af              ; Restore "AND" / "OR" flag
        pop     bc              ; Get value
        ld      a,c             ; Get LSB
        ld      hl,ACPASS       ; Address of save AC as current
        jp      nz,POR1         ; Jump if OR
        and     e               ; "AND" LSBs
        ld      c,a             ; Save LSB
        ld      a,b             ; Get MBS
        and     d               ; "AND" MSBs
        jp      (hl)            ; Save AC as current (ACPASS)

POR1:   or      e               ; "OR" LSBs
        ld      c,a             ; Save LSB
        ld      a,b             ; Get MSB
        or      d               ; "OR" MSBs
        jp      (hl)            ; Save AC as current (ACPASS)

TSTRED: ld      hl,CMPLOG       ; Logical compare routine
        ld      a,(TYPE)        ; Get data type
        rra                     ; Carry set = string
        ld      a,d             ; Get last precedence value
        rla                     ; Times 2 plus carry
        ld      e,a             ; To E
        ld      d,$64           ; Relational precedence
        ld      a,b             ; Get current precedence
        cp      d               ; Compare with last
        ret     nc              ; Eval if last was rel' or log'
        jp      STKTHS          ; Stack this one and get next

CMPLOG: dw      CMPLG1          ; Compare two values / strings
CMPLG1: ld      a,c             ; Get data type
        or      a
        rra
        pop     bc              ; Get last expression to BCDE
        pop     de
        push    af              ; Save status
        call    CHKTYP          ; Check that types match
        ld      hl,CMPRES       ; Result to comparison
        push    hl              ; Save for RETurn
        jp      z,CMPNUM        ; Compare values if numeric
        xor     a               ; Compare two strings
        ld      (TYPE),a        ; Set type to numeric
        push    de              ; Save string name
        call    GSTRCU          ; Get current string
        ld      a,(hl)          ; Get length of string
        inc     hl
        inc     hl
        ld      c,(hl)          ; Get LSB of address
        inc     hl
        ld      b,(hl)          ; Get MSB of address
        pop     de              ; Restore string name
        push    bc              ; Save address of string
        push    af              ; Save length of string
        call    GSTRDE          ; Get second string
        call    LOADFP          ; Get address of second string
        pop     af              ; Restore length of string 1
        ld      d,a             ; Length to D
        pop     hl              ; Restore address of string 1
CMPSTR: ld      a,e             ; Bytes of string 2 to do
        or      d               ; Bytes of string 1 to do
        ret     z               ; Exit if all bytes compared
        ld      a,d             ; Get bytes of string 1 to do
        sub     1
        ret     c               ; Exit if end of string 1
        xor     a
        cp      e               ; Bytes of string 2 to do
        inc     a
        ret     nc              ; Exit if end of string 2
        dec     d               ; Count bytes in string 1
        dec     e               ; Count bytes in string 2
        ld      a,(bc)          ; Byte in string 2
        cp      (hl)            ; Compare to byte in string 1
        inc     hl              ; Move up string 1
        inc     bc              ; Move up string 2
        jp      z,CMPSTR        ; Same - Try next bytes
        ccf                     ; Flag difference (">" or "<")
        jp      FLGDIF          ; "<" gives -1 , ">" gives +1

CMPRES: inc     a               ; Increment current value
        adc     a,a             ; Double plus carry
        pop     bc              ; Get other value
        and     b               ; Combine them
        add     a,-1            ; Carry set if different
        sbc     a,a             ; 00 - Equal , FF - Different
        jp      FLGREL          ; Set current value & continue

EVNOT:  ld      d,$5A           ; Precedence value for "NOT"
        call    EVAL1           ; Eval until precedence break
        call    TSTNUM          ; Make sure it's a number
        call    DEINT           ; Get integer -32768 - 32767
        ld      a,e             ; Get LSB
        cpl                     ; Invert LSB
        ld      c,a             ; Save "NOT" of LSB
        ld      a,d             ; Get MSB
        cpl                     ; Invert MSB
        call    ACPASS          ; Save AC as current
        pop     bc              ; Clean up stack
        jp      EVAL3           ; Continue evaluation

DIMRET: dec     hl              ; DEC 'cos GETCHR INCs
        call    GETCHR          ; Get next character
        ret     z               ; End of DIM statement
        call    CHKSYN          ; Make sure "," follows
        db      ","
DIM:    ld      bc,DIMRET       ; Return to "DIMRET"
        push    bc              ; Save on stack
        db      $F6            ; Flag "Create" variable
GETVAR: xor     a               ; Find variable address,to DE
        ld      (LCRFLG),a      ; Set locate / create flag
        ld      b,(hl)          ; Get First byte of name
GTFNAM: call    CHKLTR          ; See if a letter
        jp      c,SNERR         ; ?SN Error if not a letter
        xor     a
        ld      c,a             ; Clear second byte of name
        ld      (TYPE),a        ; Set type to numeric
        call    GETCHR          ; Get next character
        jp      c,SVNAM2        ; Numeric - Save in name
        call    CHKLTR          ; See if a letter
        jp      c,CHARTY        ; Not a letter - Check type
SVNAM2: ld      c,a             ; Save second byte of name
ENDNAM: call    GETCHR          ; Get next character
        jp      c,ENDNAM        ; Numeric - Get another
        call    CHKLTR          ; See if a letter
        jp      nc,ENDNAM       ; Letter - Get another
CHARTY: sub     "$"             ; String variable?
        jp      nz,NOTSTR       ; No - Numeric variable
        inc     a               ; A = 1 (string type)
        ld      (TYPE),a        ; Set type to string
        rrca                    ; A = 80H , Flag for string
        add     a,c             ; 2nd byte of name has bit 7 on
        ld      c,a             ; Resave second byte on name
        call    GETCHR          ; Get next character
NOTSTR: ld      a,(FORFLG)      ; Array name needed ?
        dec     a
        jp      z,ARLDSV        ; Yes - Get array name
        jp      p,NSCFOR        ; No array with "FOR" or "FN"
        ld      a,(hl)          ; Get byte again
        sub     "("             ; Subscripted variable?
        jp      z,SBSCPT        ; Yes - Sort out subscript

NSCFOR: xor     a               ; Simple variable
        ld      (FORFLG),a      ; Clear "FOR" flag
        push    hl              ; Save code string address
        ld      d,b             ; DE = Variable name to find
        ld      e,c
        ld      hl,(FNRGNM)     ; FN argument name
        call    CPDEHL          ; Is it the FN argument?
        ld      de,FNARG        ; Point to argument value
        jp      z,POPHRT        ; Yes - Return FN argument value
        ld      hl,(VAREND)     ; End of variables
        ex      de,hl           ; Address of end of search
        ld      hl,(PROGND)     ; Start of variables address
FNDVAR: call    CPDEHL          ; End of variable list table?
        jp      z,CFEVAL        ; Yes - Called from EVAL?
        ld      a,c             ; Get second byte of name
        sub     (hl)            ; Compare with name in list
        inc     hl              ; Move on to first byte
        jp      nz,FNTHR        ; Different - Find another
        ld      a,b             ; Get first byte of name
        sub     (hl)            ; Compare with name in list
FNTHR:  inc     hl              ; Move on to LSB of value
        jp      z,RETADR        ; Found - Return address
        inc     hl              ; <- Skip
        inc     hl              ; <- over
        inc     hl              ; <- F.P.
        inc     hl              ; <- value
        jp      FNDVAR          ; Keep looking

CFEVAL: pop     hl              ; Restore code string address
        ex      (sp),hl         ; Get return address
        push    de              ; Save address of variable
        ld      de,FRMEVL       ; Return address in EVAL
        call    CPDEHL          ; Called from EVAL ?
        pop     de              ; Restore address of variable
        jp      z,RETNUL        ; Yes - Return null variable
        ex      (sp),hl         ; Put back return
        push    hl              ; Save code string address
        push    bc              ; Save variable name
        ld      bc,6            ; 2 byte name plus 4 byte data
        ld      hl,(ARREND)     ; End of arrays
        push    hl              ; Save end of arrays
        add     hl,bc           ; Move up 6 bytes
        pop     bc              ; Source address in BC
        push    hl              ; Save new end address
        call    MOVUP           ; Move arrays up
        pop     hl              ; Restore new end address
        ld      (ARREND),hl     ; Set new end address
        ld      h,b             ; End of variables to HL
        ld      l,c
        ld      (VAREND),hl     ; Set new end address

ZEROLP: dec     hl              ; Back through to zero variable
        ld      (hl),0          ; Zero byte in variable
        call    CPDEHL          ; Done them all?
        jp      nz,ZEROLP       ; No - Keep on going
        pop     de              ; Get variable name
        ld      (hl),e          ; Store second character
        inc     hl
        ld      (hl),d          ; Store first character
        inc     hl
RETADR: ex      de,hl           ; Address of variable in DE
        pop     hl              ; Restore code string address
        ret

RETNUL: ld      (FPEXP),a       ; Set result to zero
        ld      hl,ZERBYT       ; Also set a null string
        ld      (FPREG),hl      ; Save for EVAL
        pop     hl              ; Restore code string address
        ret

SBSCPT: push    hl              ; Save code string address
        ld      hl,(LCRFLG)     ; Locate/Create and Type
        ex      (sp),hl         ; Save and get code string
        ld      d,a             ; Zero number of dimensions
SCPTLP: push    de              ; Save number of dimensions
        push    bc              ; Save array name
        call    FPSINT          ; Get subscript (0-32767)
        pop     bc              ; Restore array name
        pop     af              ; Get number of dimensions
        ex      de,hl
        ex      (sp),hl         ; Save subscript value
        push    hl              ; Save LCRFLG and TYPE
        ex      de,hl
        inc     a               ; Count dimensions
        ld      d,a             ; Save in D
        ld      a,(hl)          ; Get next byte in code string
        cp      ","             ; Comma (more to come)?
        jp      z,SCPTLP        ; Yes - More subscripts
        call    CHKSYN          ; Make sure ")" follows
        db      ")"
        ld      (NXTOPR),hl     ; Save code string address
        pop     hl              ; Get LCRFLG and TYPE
        ld      (LCRFLG),hl     ; Restore Locate/create & type
        ld      e,0             ; Flag not CSAVE* or CLOAD*
        push    de              ; Save number of dimensions (D)
        db      $11             ; Skip "PUSH HL" and "PUSH AF'

ARLDSV: push    hl              ; Save code string address
        push    af              ; A = 00 , Flags set = Z,N
        ld      hl,(VAREND)     ; Start of arrays
        db      $3E             ; Skip "ADD HL,DE"
FNDARY: add     hl,de           ; Move to next array start
        ex      de,hl
        ld      hl,(ARREND)     ; End of arrays
        ex      de,hl           ; Current array pointer
        call    CPDEHL          ; End of arrays found?
        jp      z,CREARY        ; Yes - Create array
        ld      a,(hl)          ; Get second byte of name
        cp      c               ; Compare with name given
        inc     hl              ; Move on
        jp      nz,NXTARY       ; Different - Find next array
        ld      a,(hl)          ; Get first byte of name
        cp      b               ; Compare with name given
NXTARY: inc     hl              ; Move on
        ld      e,(hl)          ; Get LSB of next array address
        inc     hl
        ld      d,(hl)          ; Get MSB of next array address
        inc     hl
        jp      nz,FNDARY       ; Not found - Keep looking
        ld      a,(LCRFLG)      ; Found Locate or Create it?
        or      a
        jp      nz,DDERR        ; Create - ?DD Error
        pop     af              ; Locate - Get number of dim'ns
        ld      b,h             ; BC Points to array dim'ns
        ld      c,l
        jp      z,POPHRT        ; Jump if array load/save
        sub     (hl)            ; Same number of dimensions?
        jp      z,FINDEL        ; Yes - Find element
BSERR:  ld      e,BS            ; ?BS Error
        jp      ERROR           ; Output error

CREARY: ld      de,4            ; 4 Bytes per entry
        pop     af              ; Array to save or 0 dim'ns?
        jp      z,FCERR         ; Yes - ?FC Error
        ld      (hl),c          ; Save second byte of name
        inc     hl
        ld      (hl),b          ; Save first byte of name
        inc     hl
        ld      c,a             ; Number of dimensions to C
        call    CHKSTK          ; Check if enough memory
        inc     hl              ; Point to number of dimensions
        inc     hl
        ld      (CUROPR),hl     ; Save address of pointer
        ld      (hl),c          ; Set number of dimensions
        inc     hl
        ld      a,(LCRFLG)      ; Locate of Create?
        rla                     ; Carry set = Create
        ld      a,c             ; Get number of dimensions
CRARLP: ld      bc,10+1         ; Default dimension size 10
        jp      nc,DEFSIZ       ; Locate - Set default size
        pop     bc              ; Get specified dimension size
        inc     bc              ; Include zero element
DEFSIZ: ld      (hl),c          ; Save LSB of dimension size
        inc     hl
        ld      (hl),b          ; Save MSB of dimension size
        inc     hl
        push    af              ; Save num' of dim'ns an status
        push    hl              ; Save address of dim'n size
        call    MLDEBC          ; Multiply DE by BC to find
        ex      de,hl           ; amount of mem needed (to DE)
        pop     hl              ; Restore address of dimension
        pop     af              ; Restore number of dimensions
        dec     a               ; Count them
        jp      nz,CRARLP       ; Do next dimension if more
        push    af              ; Save locate/create flag
        ld      b,d             ; MSB of memory needed
        ld      c,e             ; LSB of memory needed
        ex      de,hl
        add     hl,de           ; Add bytes to array start
        jp      c,OMERR         ; Too big - Error
        call    ENFMEM          ; See if enough memory
        ld      (ARREND),hl     ; Save new end of array

ZERARY: dec     hl              ; Back through array data
        ld      (hl),0          ; Set array element to zero
        call    CPDEHL          ; All elements zeroed?
        jp      nz,ZERARY       ; No - Keep on going
        inc     bc              ; Number of bytes + 1
        ld      d,a             ; A=0
        ld      hl,(CUROPR)     ; Get address of array
        ld      e,(hl)          ; Number of dimensions
        ex      de,hl           ; To HL
        add     hl,hl           ; Two bytes per dimension size
        add     hl,bc           ; Add number of bytes
        ex      de,hl           ; Bytes needed to DE
        dec     hl
        dec     hl
        ld      (hl),e          ; Save LSB of bytes needed
        inc     hl
        ld      (hl),d          ; Save MSB of bytes needed
        inc     hl
        pop     af              ; Locate / Create?
        jp      c,ENDDIM        ; A is 0 , End if create
FINDEL: ld      b,a             ; Find array element
        ld      c,a
        ld      a,(hl)          ; Number of dimensions
        inc     hl
        db      $16             ; Skip "POP HL"
FNDELP: pop     hl              ; Address of next dim' size
        ld      e,(hl)          ; Get LSB of dim'n size
        inc     hl
        ld      d,(hl)          ; Get MSB of dim'n size
        inc     hl
        ex      (sp),hl         ; Save address - Get index
        push    af              ; Save number of dim'ns
        call    CPDEHL          ; Dimension too large?
        jp      nc,BSERR        ; Yes - ?BS Error
        push    hl              ; Save index
        call    MLDEBC          ; Multiply previous by size
        pop     de              ; Index supplied to DE
        add     hl,de           ; Add index to pointer
        pop     af              ; Number of dimensions
        dec     a               ; Count them
        ld      b,h             ; MSB of pointer
        ld      c,l             ; LSB of pointer
        jp      nz,FNDELP       ; More - Keep going
        add     hl,hl           ; 4 Bytes per element
        add     hl,hl
        pop     bc              ; Start of array
        add     hl,bc           ; Point to element
        ex      de,hl           ; Address of element to DE
ENDDIM: ld      hl,(NXTOPR)     ; Got code string address
        ret

FRE:    ld      hl,(ARREND)     ; Start of free memory
        ex      de,hl           ; To DE
        ld      hl,0            ; End of free memory
        add     hl,sp           ; Current stack value
        ld      a,(TYPE)        ; Dummy argument type
        or      a
        jp      z,FRENUM        ; Numeric - Free variable space
        call    GSTRCU          ; Current string to pool
        call    GARBGE          ; Garbage collection
        ld      hl,(STRSPC)     ; Bottom of string space in use
        ex      de,hl           ; To DE
        ld      hl,(STRBOT)     ; Bottom of string space
FRENUM: ld      a,l             ; Get LSB of end
        sub     e               ; Subtract LSB of beginning
        ld      c,a             ; Save difference if C
        ld      a,h             ; Get MSB of end
        sbc     a,d             ; Subtract MSB of beginning
ACPASS: ld      b,c             ; Return integer AC
ABPASS: ld      d,b             ; Return integer AB
        ld      e,0
        ld      hl,TYPE         ; Point to type
        ld      (hl),e          ; Set type to numeric
        ld      b,$80+16        ; 16 bit integer
        jp      RETINT          ; Return the integr

POS:    ld      a,(CURPOS)      ; Get cursor position
PASSA:  ld      b,a             ; Put A into AB
        xor     a               ; Zero A
        jp      ABPASS          ; Return integer AB

fdef:   call    CHEKFN          ; Get "FN" and name
        call    IDTEST          ; Test for illegal direct
        ld      bc,DATA         ; To get next statement
        push    bc              ; Save address for RETurn
        push    de              ; Save address of function ptr
        call    CHKSYN          ; Make sure "(" follows
        db      "("
        call    GETVAR          ; Get argument variable name
        push    hl              ; Save code string address
        ex      de,hl           ; Argument address to HL
        dec     hl
        ld      d,(hl)          ; Get first byte of arg name
        dec     hl
        ld      e,(hl)          ; Get second byte of arg name
        pop     hl              ; Restore code string address
        call    TSTNUM          ; Make sure numeric argument
        call    CHKSYN          ; Make sure ")" follows
        db      ")"
        call    CHKSYN          ; Make sure "=" follows
        db      ZEQUAL          ; "=" token
        ld      b,h             ; Code string address to BC
        ld      c,l
        ex      (sp),hl         ; Save code str , Get FN ptr
        ld      (hl),c          ; Save LSB of FN code string
        inc     hl
        ld      (hl),b          ; Save MSB of FN code string
        jp      SVSTAD          ; Save address and do function

DOFN:   call    CHEKFN          ; Make sure FN follows
        push    de              ; Save function pointer address
        call    EVLPAR          ; Evaluate expression in "()"
        call    TSTNUM          ; Make sure numeric result
        ex      (sp),hl         ; Save code str , Get FN ptr
        ld      e,(hl)          ; Get LSB of FN code string
        inc     hl
        ld      d,(hl)          ; Get MSB of FN code string
        inc     hl
        ld      a,d             ; And function DEFined?
        or      e
        jp      z,UFERR         ; No - ?UF Error
        ld      a,(hl)          ; Get LSB of argument address
        inc     hl
        ld      h,(hl)          ; Get MSB of argument address
        ld      l,a             ; HL = Arg variable address
        push    hl              ; Save it
        ld      hl,(FNRGNM)     ; Get old argument name
        ex      (sp),hl ;       ; Save old , Get new
        ld      (FNRGNM),hl     ; Set new argument name
        ld      hl,(FNARG+2)    ; Get LSB,NLSB of old arg value
        push    hl              ; Save it
        ld      hl,(FNARG)      ; Get MSB,EXP of old arg value
        push    hl              ; Save it
        ld      hl,FNARG        ; HL = Value of argument
        push    de              ; Save FN code string address
        call    FPTHL           ; Move FPREG to argument
        pop     hl              ; Get FN code string address
        call    GETNUM          ; Get value from function
        dec     hl              ; DEC 'cos GETCHR INCs
        call    GETCHR          ; Get next character
        jp      nz,SNERR        ; Bad character in FN - Error
        pop     hl              ; Get MSB,EXP of old arg
        ld      (FNARG),hl      ; Restore it
        pop     hl              ; Get LSB,NLSB of old arg
        ld      (FNARG+2),hl    ; Restore it
        pop     hl              ; Get name of old arg
        ld      (FNRGNM),hl     ; Restore it
        pop     hl              ; Restore code string address
        ret

IDTEST: push    hl              ; Save code string address
        ld      hl,(LINEAT)     ; Get current line number
        inc     hl              ; -1 means direct statement
        ld      a,h
        or      l
        pop     hl              ; Restore code string address
        ret     nz              ; Return if in program
        ld      e,ID            ; ?ID Error
        jp      ERROR

CHEKFN: call    CHKSYN          ; Make sure FN follows
        db      ZFN             ; "FN" token
        ld      a,$80
        ld      (FORFLG),a      ; Flag FN name to find
        or      (hl)            ; FN name has bit 7 set
        ld      b,a             ; in first byte of name
        call    GTFNAM          ; Get FN name
        jp      TSTNUM          ; Make sure numeric function

STR:    call    TSTNUM          ; Make sure it's a number
        call    NUMASC          ; Turn number into text
        call    CRTST           ; Create string entry for it
        call    GSTRCU          ; Current string to pool
        ld      bc,TOPOOL       ; Save in string pool
        push    bc              ; Save address on stack

SAVSTR: ld      a,(hl)          ; Get string length
        inc     hl
        inc     hl
        push    hl              ; Save pointer to string
        call    TESTR           ; See if enough string space
        pop     hl              ; Restore pointer to string
        ld      c,(hl)          ; Get LSB of address
        inc     hl
        ld      b,(hl)          ; Get MSB of address
        call    CRTMST          ; Create string entry
        push    hl              ; Save pointer to MSB of addr
        ld      l,a             ; Length of string
        call    TOSTRA          ; Move to string area
        pop     de              ; Restore pointer to MSB
        ret

MKTMST: call    TESTR           ; See if enough string space
CRTMST: ld      hl,TMPSTR       ; Temporary string
        push    hl              ; Save it
        ld      (hl),a          ; Save length of string
        inc     hl
SVSTAD: inc     hl
        ld      (hl),e          ; Save LSB of address
        inc     hl
        ld      (hl),d          ; Save MSB of address
        pop     hl              ; Restore pointer
        ret

CRTST:  dec     hl              ; DEC - INCed after
QTSTR:  ld      b,'"'           ; Terminating quote
        ld      d,b             ; Quote to D
DTSTR:  push    hl              ; Save start
        ld      c,-1            ; Set counter to -1
QTSTLP: inc     hl              ; Move on
        ld      a,(hl)          ; Get byte
        inc     c               ; Count bytes
        or      a               ; End of line?
        jp      z,CRTSTE        ; Yes - Create string entry
        cp      d               ; Terminator D found?
        jp      z,CRTSTE        ; Yes - Create string entry
        cp      b               ; Terminator B found?
        jp      nz,QTSTLP       ; No - Keep looking
CRTSTE: cp      '"'             ; End with '"'?
        call    z,GETCHR        ; Yes - Get next character
        ex      (sp),hl         ; Starting quote
        inc     hl              ; First byte of string
        ex      de,hl           ; To DE
        ld      a,c             ; Get length
        call    CRTMST          ; Create string entry
TSTOPL: ld      de,TMPSTR       ; Temporary string
        ld      hl,(TMSTPT)     ; Temporary string pool pointer
        ld      (FPREG),hl      ; Save address of string ptr
        ld      a,1
        ld      (TYPE),a        ; Set type to string
        call    DETHL4          ; Move string to pool
        call    CPDEHL          ; Out of string pool?
        ld      (TMSTPT),hl     ; Save new pointer
        pop     hl              ; Restore code string address
        ld      a,(hl)          ; Get next code byte
        ret     nz              ; Return if pool OK
        ld      e,ST            ; ?ST Error
        jp      ERROR           ; String pool overflow

PRNUMS: inc     hl              ; Skip leading space
PRS:    call    CRTST           ; Create string entry for it
PRS1:   call    GSTRCU          ; Current string to pool
        call    LOADFP          ; Move string block to BCDE
        inc     e               ; Length + 1
PRSLP:  dec     e               ; Count characters
        ret     z               ; End of string
        ld      a,(bc)          ; Get byte to output
        call    OUTC            ; Output character in A
        cp      CR              ; Return?
        call    z,DONULL        ; Yes - Do nulls
        inc     bc              ; Next byte in string
        jp      PRSLP           ; More characters to output

TESTR:  or      a               ; Test if enough room
        db      $0E             ; No garbage collection done
GRBDON: pop     af              ; Garbage collection done
        push    af              ; Save status
        ld      hl,(STRSPC)     ; Bottom of string space in use
        ex      de,hl           ; To DE
        ld      hl,(STRBOT)     ; Bottom of string area
        cpl                     ; Negate length (Top down)
        ld      c,a             ; -Length to BC
        ld      b,-1            ; BC = -ve length of string
        add     hl,bc           ; Add to bottom of space in use
        inc     hl              ; Plus one for 2's complement
        call    CPDEHL          ; Below string RAM area?
        jp      c,TESTOS        ; Tidy up if not done else err
        ld      (STRBOT),hl     ; Save new bottom of area
        inc     hl              ; Point to first byte of string
        ex      de,hl           ; Address to DE
POPAF:  pop     af              ; Throw away status push
        ret

TESTOS: pop     af              ; Garbage collect been done?
        ld      e,OS            ; ?OS Error
        jp      z,ERROR         ; Yes - Not enough string apace
        cp      a               ; Flag garbage collect done
        push    af              ; Save status
        ld      bc,GRBDON       ; Garbage collection done
        push    bc              ; Save for RETurn
GARBGE: ld      hl,(LSTRAM)     ; Get end of RAM pointer
GARBLP: ld      (STRBOT),hl     ; Reset string pointer
        ld      hl,0
        push    hl              ; Flag no string found
        ld      hl,(STRSPC)     ; Get bottom of string space
        push    hl              ; Save bottom of string space
        ld      hl,TMSTPL       ; Temporary string pool
GRBLP:  ex      de,hl
        ld      hl,(TMSTPT)     ; Temporary string pool pointer
        ex      de,hl
        call    CPDEHL          ; Temporary string pool done?
        ld      bc,GRBLP        ; Loop until string pool done
        jp      nz,STPOOL       ; No - See if in string area
        ld      hl,(PROGND)     ; Start of simple variables
SMPVAR: ex      de,hl
        ld      hl,(VAREND)     ; End of simple variables
        ex      de,hl
        call    CPDEHL          ; All simple strings done?
        jp      z,ARRLP         ; Yes - Do string arrays
        ld      a,(hl)          ; Get type of variable
        inc     hl
        inc     hl
        or      a               ; "S" flag set if string
        call    STRADD          ; See if string in string area
        jp      SMPVAR          ; Loop until simple ones done

GNXARY: pop     bc              ; Scrap address of this array
ARRLP:  ex      de,hl
        ld      hl,(ARREND)     ; End of string arrays
        ex      de,hl
        call    CPDEHL          ; All string arrays done?
        jp      z,SCNEND        ; Yes - Move string if found
        call    LOADFP          ; Get array name to BCDE
        ld      a,e             ; Get type of array
        push    hl              ; Save address of num of dim'ns
        add     hl,bc           ; Start of next array
        or      a               ; Test type of array
        jp      p,GNXARY        ; Numeric array - Ignore it
        ld      (CUROPR),hl     ; Save address of next array
        pop     hl              ; Get address of num of dim'ns
        ld      c,(hl)          ; BC = Number of dimensions
        ld      b,0
        add     hl,bc           ; Two bytes per dimension size
        add     hl,bc
        inc     hl              ; Plus one for number of dim'ns
GRBARY: ex      de,hl
        ld      hl,(CUROPR)     ; Get address of next array
        ex      de,hl
        call    CPDEHL          ; Is this array finished?
        jp      z,ARRLP         ; Yes - Get next one
        ld      bc,GRBARY       ; Loop until array all done
STPOOL: push    bc              ; Save return address
        or      $80             ; Flag string type
STRADD: ld      a,(hl)          ; Get string length
        inc     hl
        inc     hl
        ld      e,(hl)          ; Get LSB of string address
        inc     hl
        ld      d,(hl)          ; Get MSB of string address
        inc     hl
        ret     p               ; Not a string - Return
        or      a               ; Set flags on string length
        ret     z               ; Null string - Return
        ld      b,h             ; Save variable pointer
        ld      c,l
        ld      hl,(STRBOT)     ; Bottom of new area
        call    CPDEHL          ; String been done?
        ld      h,b             ; Restore variable pointer
        ld      l,c
        ret     c               ; String done - Ignore
        pop     hl              ; Return address
        ex      (sp),hl         ; Lowest available string area
        call    CPDEHL          ; String within string area?
        ex      (sp),hl         ; Lowest available string area
        push    hl              ; Re-save return address
        ld      h,b             ; Restore variable pointer
        ld      l,c
        ret     nc              ; Outside string area - Ignore
        pop     bc              ; Get return , Throw 2 away
        pop     af              ;
        pop     af              ;
        push    hl              ; Save variable pointer
        push    de              ; Save address of current
        push    bc              ; Put back return address
        ret                     ; Go to it

SCNEND: pop     de              ; Addresses of strings
        pop     hl              ;
        ld      a,l             ; HL = 0 if no more to do
        or      h
        ret     z               ; No more to do - Return
        dec     hl
        ld      b,(hl)          ; MSB of address of string
        dec     hl
        ld      c,(hl)          ; LSB of address of string
        push    hl              ; Save variable address
        dec     hl
        dec     hl
        ld      l,(hl)          ; HL = Length of string
        ld      h,0
        add     hl,bc           ; Address of end of string+1
        ld      d,b             ; String address to DE
        ld      e,c
        dec     hl              ; Last byte in string
        ld      b,h             ; Address to BC
        ld      c,l
        ld      hl,(STRBOT)     ; Current bottom of string area
        call    MOVSTR          ; Move string to new address
        pop     hl              ; Restore variable address
        ld      (hl),c          ; Save new LSB of address
        inc     hl
        ld      (hl),b          ; Save new MSB of address
        ld      l,c             ; Next string area+1 to HL
        ld      h,b
        dec     hl              ; Next string area address
        jp      GARBLP          ; Look for more strings

CONCAT: push    bc              ; Save prec' opr & code string
        push    hl              ;
        ld      hl,(FPREG)      ; Get first string
        ex      (sp),hl         ; Save first string
        call    OPRND           ; Get second string
        ex      (sp),hl         ; Restore first string
        call    TSTSTR          ; Make sure it's a string
        ld      a,(hl)          ; Get length of second string
        push    hl              ; Save first string
        ld      hl,(FPREG)      ; Get second string
        push    hl              ; Save second string
        add     a,(hl)          ; Add length of second string
        ld      e,LS            ; ?LS Error
        jp      c,ERROR         ; String too long - Error
        call    MKTMST          ; Make temporary string
        pop     de              ; Get second string to DE
        call    GSTRDE          ; Move to string pool if needed
        ex      (sp),hl         ; Get first string
        call    GSTRHL          ; Move to string pool if needed
        push    hl              ; Save first string
        ld      hl,(TMPSTR+2)   ; Temporary string address
        ex      de,hl           ; To DE
        call    SSTSA           ; First string to string area
        call    SSTSA           ; Second string to string area
        ld      hl,EVAL2        ; Return to evaluation loop
        ex      (sp),hl         ; Save return,get code string
        push    hl              ; Save code string address
        jp      TSTOPL          ; To temporary string to pool

SSTSA:  pop     hl              ; Return address
        ex      (sp),hl         ; Get string block,save return
        ld      a,(hl)          ; Get length of string
        inc     hl
        inc     hl
        ld      c,(hl)          ; Get LSB of string address
        inc     hl
        ld      b,(hl)          ; Get MSB of string address
        ld      l,a             ; Length to L
TOSTRA: inc     l               ; INC - DECed after
TSALP:  dec     l               ; Count bytes moved
        ret     z               ; End of string - Return
        ld      a,(bc)          ; Get source
        ld      (de),a          ; Save destination
        inc     bc              ; Next source
        inc     de              ; Next destination
        jp      TSALP           ; Loop until string moved

GETSTR: call    TSTSTR          ; Make sure it's a string
GSTRCU: ld      hl,(FPREG)      ; Get current string
GSTRHL: ex      de,hl           ; Save DE
GSTRDE: call    BAKTMP          ; Was it last tmp-str?
        ex      de,hl           ; Restore DE
        ret     nz              ; No - Return
        push    de              ; Save string
        ld      d,b             ; String block address to DE
        ld      e,c
        dec     de              ; Point to length
        ld      c,(hl)          ; Get string length
        ld      hl,(STRBOT)     ; Current bottom of string area
        call    CPDEHL          ; Last one in string area?
        jp      nz,POPHL        ; No - Return
        ld      b,a             ; Clear B (A=0)
        add     hl,bc           ; Remove string from str' area
        ld      (STRBOT),hl     ; Save new bottom of str' area
POPHL:  pop     hl              ; Restore string
        ret

BAKTMP: ld      hl,(TMSTPT)     ; Get temporary string pool top
        dec     hl              ; Back
        ld      b,(hl)          ; Get MSB of address
        dec     hl              ; Back
        ld      c,(hl)          ; Get LSB of address
        dec     hl              ; Back
        dec     hl              ; Back
        call    CPDEHL          ; String last in string pool?
        ret     nz              ; Yes - Leave it
        ld      (TMSTPT),hl     ; Save new string pool top
        ret

LEN:    ld      bc,PASSA        ; To return integer A
        push    bc              ; Save address
GETLEN: call    GETSTR          ; Get string and its length
        xor     a
        ld      d,a             ; Clear D
        ld      (TYPE),a        ; Set type to numeric
        ld      a,(hl)          ; Get length of string
        or      a               ; Set status flags
        ret

ASC:    ld      bc,PASSA        ; To return integer A
        push    bc              ; Save address
GTFLNM: call    GETLEN          ; Get length of string
        jp      z,FCERR         ; Null string - Error
        inc     hl
        inc     hl
        ld      e,(hl)          ; Get LSB of address
        inc     hl
        ld      d,(hl)          ; Get MSB of address
        ld      a,(de)          ; Get first byte of string
        ret

fCHR:   ld      a,1             ; One character string
        call    MKTMST          ; Make a temporary string
        call    MAKINT          ; Make it integer A
        ld      hl,(TMPSTR+2)   ; Get address of string
        ld      (hl),e          ; Save character
TOPOOL: pop     bc              ; Clean up stack
        jp      TSTOPL          ; Temporary string to pool

LEFT:   call    LFRGNM          ; Get number and ending ")"
        xor     a               ; Start at first byte in string
RIGHT1: ex      (sp),hl         ; Save code string,Get string
        ld      c,a             ; Starting position in string
MID1:   push    hl              ; Save string block address
        ld      a,(hl)          ; Get length of string
        cp      b               ; Compare with number given
        jp      c,ALLFOL        ; All following bytes required
        ld      a,b             ; Get new length
        db      $11             ; Skip "LD C,0"
ALLFOL: ld      c,0             ; First byte of string
        push    bc              ; Save position in string
        call    TESTR           ; See if enough string space
        pop     bc              ; Get position in string
        pop     hl              ; Restore string block address
        push    hl              ; And re-save it
        inc     hl
        inc     hl
        ld      b,(hl)          ; Get LSB of address
        inc     hl
        ld      h,(hl)          ; Get MSB of address
        ld      l,b             ; HL = address of string
        ld      b,0             ; BC = starting address
        add     hl,bc           ; Point to that byte
        ld      b,h             ; BC = source string
        ld      c,l
        call    CRTMST          ; Create a string entry
        ld      l,a             ; Length of new string
        call    TOSTRA          ; Move string to string area
        pop     de              ; Clear stack
        call    GSTRDE          ; Move to string pool if needed
        jp      TSTOPL          ; Temporary string to pool

RIGHT:  call    LFRGNM          ; Get number and ending ")"
        pop     de              ; Get string length
        push    de              ; And re-save
        ld      a,(de)          ; Get length
        sub     b               ; Move back N bytes
        jp      RIGHT1          ; Go and get sub-string

MID:    ex      de,hl           ; Get code string address
        ld      a,(hl)          ; Get next byte "," or ")"
        call    MIDNUM          ; Get number supplied
        inc     b               ; Is it character zero?
        dec     b
        jp      z,FCERR         ; Yes - Error
        push    bc              ; Save starting position
        ld      e,255           ; All of string
        cp      ")"             ; Any length given?
        jp      z,RSTSTR        ; No - Rest of string
        call    CHKSYN          ; Make sure "," follows
        db      ","
        call    GETINT          ; Get integer 0-255
RSTSTR: call    CHKSYN          ; Make sure ")" follows
        db      ")"
        pop     af              ; Restore starting position
        ex      (sp),hl         ; Get string,8ave code string
        ld      bc,MID1         ; Continuation of MID$ routine
        push    bc              ; Save for return
        dec     a               ; Starting position-1
        cp      (hl)            ; Compare with length
        ld      b,0             ; Zero bytes length
        ret     nc              ; Null string if start past end
        ld      c,a             ; Save starting position-1
        ld      a,(hl)          ; Get length of string
        sub     c               ; Subtract start
        cp      e               ; Enough string for it?
        ld      b,a             ; Save maximum length available
        ret     c               ; Truncate string if needed
        ld      b,e             ; Set specified length
        ret                     ; Go and create string

VAL:    call    GETLEN          ; Get length of string
        jp      z,RESZER        ; Result zero
        ld      e,a             ; Save length
        inc     hl
        inc     hl
        ld      a,(hl)          ; Get LSB of address
        inc     hl
        ld      h,(hl)          ; Get MSB of address
        ld      l,a             ; HL = String address
        push    hl              ; Save string address
        add     hl,de
        ld      b,(hl)          ; Get end of string+1 byte
        ld      (hl),d          ; Zero it to terminate
        ex      (sp),hl         ; Save string end,get start
        push    bc              ; Save end+1 byte
        ld      a,(hl)          ; Get starting byte
        call    ASCTFP          ; Convert ASCII string to FP
        pop     bc              ; Restore end+1 byte
        pop     hl              ; Restore end+1 address
        ld      (hl),b          ; Put back original byte
        ret

LFRGNM: ex      de,hl           ; Code string address to HL
        call    CHKSYN          ; Make sure ")" follows
        db      ")"
MIDNUM: pop     bc              ; Get return address
        pop     de              ; Get number supplied
        push    bc              ; Re-save return address
        ld      b,e             ; Number to B
        ret

INP:    call    MAKINT          ; Make it integer A
        ld      (INPORT),a      ; Set input port
        call    INPSUB          ; Get input from port
        jp      PASSA           ; Return integer A

POUT:   call    SETIO           ; Set up port number
        jp      OUTSUB          ; Output data and return

WAIT:   call    SETIO           ; Set up port number
        push    af              ; Save AND mask
        ld      e,0             ; Assume zero if none given
        dec     hl              ; DEC 'cos GETCHR INCs
        call    GETCHR          ; Get next character
        jp      z,NOXOR         ; No XOR byte given
        call    CHKSYN          ; Make sure "," follows
        db      ","
        call    GETINT          ; Get integer 0-255 to XOR with
NOXOR:  pop     bc              ; Restore AND mask
WAITLP: call    INPSUB          ; Get input
        xor     e               ; Flip selected bits
        and     b               ; Result non-zero?
        jp      z,WAITLP        ; No = keep waiting
        ret

SETIO:  call    GETINT          ; Get integer 0-255
        ld      (INPORT),a      ; Set input port
        ld      (OTPORT),a      ; Set output port
        call    CHKSYN          ; Make sure "," follows
        db      ","
        jp      GETINT          ; Get integer 0-255 and return

FNDNUM: call    GETCHR          ; Get next character
GETINT: call    GETNUM          ; Get a number from 0 to 255
MAKINT: call    DEPINT          ; Make sure value 0 - 255
        ld      a,d             ; Get MSB of number
        or      a               ; Zero?
        jp      nz,FCERR        ; No - Error
        dec     hl              ; DEC 'cos GETCHR INCs
        call    GETCHR          ; Get next character
        ld      a,e             ; Get number to A
        ret

; << NO  REFERENCE  TO  THIS  SECTION  OF  CODE >>
; << Set up another program area (can be in ROM) >>

        ld      hl,(BASTXT)     ; Get start of program text
        ld      (PROGND),hl     ; Set more variable space
        ld      hl,$8000        ; Address of new program
        ld      e,(hl)          ; Get LSB of new RAM end
        inc     hl
        ld      d,(hl)          ; Get MSB of new RAM end
        inc     hl
        inc     hl              ; Null at start of program
        ld      (BASTXT),hl     ; New program text area 8003H
        ex      de,hl           ; New RAM end to HL
        ld      (LSTRAM),hl     ; Set new RAM end
        ld      (STRSPC),hl     ; Clear string space
        ld      bc,RUNCNT       ; Execution driver loop
        push    bc              ; Save for return
        jp      RUNFST          ; Clear variables and continue

RUART:  jp      GUART           ; Get a byte from UART

WUART2: call    WUART           ; Send 2 Bytes to UART
WUART:  push    af              ; Save byte
        push    bc              ; Save BC
        ld      c,a             ; Byte to C
        call    SUART           ; Send byte to UART
        pop     bc              ; Restore BC
        pop     af              ; Restore byte
        ret

CSAVE:  ld      b,1             ; Flag "CSAVE"
        cp      ZTIMES          ; "*" token? ("CSAVE*")
        jp      z,ARRSV1        ; Yes - Array save
        call    EVAL            ; Evaluate expression
        push    hl              ; Save code string address
        call    GTFLNM          ; Get file name
        push    de              ; Save file name
        call    CASFFW          ; Turn on motor and wait
        pop     de              ; Restore file name
        ld      a,%11010011     ; Header byte
        call    WUART           ; Send byte to UART
        call    WUART2          ; Send byte twice more
        ld      a,(de)          ; Get file name
        call    WUART           ; Send it to UART
        nop
        nop
        nop
        ld      hl,PROGND       ; Start of program information
        ld      (ARG1),hl       ; Save for monitor save routine
        ld      hl,(PROGND)     ; End of program information
        ld      (ARG2),hl       ; Save for monitor save routine
        call    SAVE            ; Save program to tape
        call    ARET            ; Not much there!
        pop     hl              ; Restore code string address
        ret

CLOAD:  ld      a,(hl)          ; Get byte after "CLOAD"
        cp      ZTIMES          ; "*" token? ("CLOAD*")
        jp      z,ARRLD1        ; Yes - Array load
        call    SMOTOR          ; Start motor and get "?"
        sub     ZPRINT          ; "?" ("PRINT" token) Verify?
        jp      z,FLGVER        ; Yes - Flag "verify"
        xor     a               ; Flag "load"
        db      $01             ; Skip "CPL" and "INC HL"
FLGVER: cpl                     ; Flag "verify"
        inc     hl              ; Skip over "?"
        push    af              ; Save verify flag
        dec     hl              ; DEC 'cos GETCHR INCs
        call    GETCHR          ; Get next character
        ld      a,0             ; Any file will do
        jp      z,ANYNAM        ; No name given - Any will do
        call    EVAL            ; Evaluate expression
        call    GTFLNM          ; Get file name
        ld      a,(de)          ; Get first byte of name
ANYNAM: ld      l,a             ; Save name to find
        pop     af              ; Get verify flag
        push    af              ; And re-save
        or      a               ; Verify of load?
        ld      h,a
        ld      (FPREG),hl      ; Save nam of file to find
        call    z,CLRPTR        ; Load - Clear pointers
        ld      hl,(FPREG)      ; Get name of program to find
        ex      de,hl           ; Name to DE
CLOAD1: ld      b,3             ; 3 Header bytes
CLOAD2: call    RUART           ; Get a byte from UART
        sub     %11010011       ; Header byte?
        jp      nz,CLOAD1       ; Look for header
        dec     b               ; Count header bytes
        jp      nz,CLOAD2       ; More to find?
        call    RUART           ; Get name of file
        call    FILFND          ; Display "file X found"
        inc     e               ; Any file name given?
        dec     e
        jp      z,THSFIL        ; No - This file will do
        cp      e               ; Has file been found?
        jp      nz,CLOAD1       ; No - Look for another
THSFIL: nop
        nop
        nop
        pop     af              ; Get verify flag
        or      a               ; Load or verify?
        jp      nz,CLOADV       ; Verify program
        call    MONLD           ; Use monitor to load program
        ld      hl,(PROGND)     ; Get end of program
        call    ENFMEM          ; See if enough memory
        jp      CLOADE          ; "Ok" and set up pointers

CLOADV: call    MONVE           ; Use monitor to verify program
CLOADE: ld      hl,OKMSG        ; "Ok" message
        call    PRS             ; Output string
        call    ARET            ; Not a lot there!
        jp      SETPTR          ; Set up line pointers

OUTBAD: ld      hl,BAD          ; "Bad" message
        call    PRS             ; Output string
        jp      ERRIN           ; In line message

FILFND: push    bc              ; <- Save
        push    hl              ; <- all
        push    de              ; <- the
        push    af              ; <- registers
        ld      hl,FILE         ; "File" message
        call    PRS             ; Output string
        pop     af              ; Get file name
        push    af              ; And re-save
        call    CONMON          ; Output file name to screen
        ld      hl,FOUND        ; "Found" message
        call    PRS             ; Output string
        pop     af              ; <- Restore
        pop     de              ; <- all
        pop     hl              ; <- the
        pop     bc              ; <- registers
        ret

FILE:   db      "File ",0
FOUND:  db      " Found",CR,LF,0
BAD:    db      "Bad",0,0,0

PEEK:   call    DEINT           ; Get memory address
        ld      a,(de)          ; Get byte in memory
        jp      PASSA           ; Return integer A

POKE:   call    GETNUM          ; Get memory address
        call    DEINT           ; Get integer -32768 to 3276
        push    de              ; Save memory address
        call    CHKSYN          ; Make sure "," follows
        db      ","
        call    GETINT          ; Get integer 0-255
        pop     de              ; Restore memory address
        ld      (de),a          ; Load it into memory
        ret

fround: ld      hl,HALF         ; Add 0.5 to FPREG
ADDPHL: call    LOADFP          ; Load FP at (HL) to BCDE
        jp      FPADD           ; Add BCDE to FPREG

SUBPHL: call    LOADFP          ; FPREG = -FPREG + number at HL
        db      $21             ; Skip "POP BC" and "POP DE"
PSUB:   pop     bc              ; Get FP number from stack
        pop     de
SUBCDE: call    INVSGN          ; Negate FPREG
FPADD:  ld      a,b             ; Get FP exponent
        or      a               ; Is number zero?
        ret     z               ; Yes - Nothing to add
        ld      a,(FPEXP)       ; Get FPREG exponent
        or      a               ; Is this number zero?
        jp      z,FPBCDE        ; Yes - Move BCDE to FPREG
        sub     b               ; BCDE number larger?
        jp      nc,NOSWAP       ; No - Don't swap them
        cpl                     ; Two's complement
        inc     a               ;  FP exponent
        ex      de,hl
        call    STAKFP          ; Put FPREG on stack
        ex      de,hl
        call    FPBCDE          ; Move BCDE to FPREG
        pop     bc              ; Restore number from stack
        pop     de
NOSWAP: cp      24+1            ; Second number insignificant?
        ret     nc              ; Yes - First number is result
        push    af              ; Save number of bits to scale
        call    SIGNS           ; Set MSBs & sign of result
        ld      h,a             ; Save sign of result
        pop     af              ; Restore scaling factor
        call    SCALE           ; Scale BCDE to same exponent
        or      h               ; Result to be positive?
        ld      hl,FPREG        ; Point to FPREG
        jp      p,MINCDE        ; No - Subtract FPREG from CDE
        call    PLUCDE          ; Add FPREG to CDE
        jp      nc,RONDUP       ; No overflow - Round it up
        inc     hl              ; Point to exponent
        inc     (hl)            ; Increment it
        jp      z,OVERR         ; Number overflowed - Error
        ld      l,1             ; 1 bit to shift right
        call    SHRT1           ; Shift result right
        jp      RONDUP          ; Round it up

MINCDE: xor     a               ; Clear A and carry
        sub     b               ; Negate exponent
        ld      b,a             ; Re-save exponent
        ld      a,(hl)          ; Get LSB of FPREG
        sbc     a, e            ; Subtract LSB of BCDE
        ld      e,a             ; Save LSB of BCDE
        inc     hl
        ld      a,(hl)          ; Get NMSB of FPREG
        sbc     a,d             ; Subtract NMSB of BCDE
        ld      d,a             ; Save NMSB of BCDE
        inc     hl
        ld      a,(hl)          ; Get MSB of FPREG
        sbc     a,c             ; Subtract MSB of BCDE
        ld      c,a             ; Save MSB of BCDE
CONPOS: call    c,COMPL         ; Overflow - Make it positive

BNORM:  ld      l,b             ; L = Exponent
        ld      h,e             ; H = LSB
        xor     a
BNRMLP: ld      b,a             ; Save bit count
        ld      a,c             ; Get MSB
        or      a               ; Is it zero?
        jp      nz,PNORM        ; No - Do it bit at a time
        ld      c,d             ; MSB = NMSB
        ld      d,h             ; NMSB= LSB
        ld      h,l             ; LSB = VLSB
        ld      l,a             ; VLSB= 0
        ld      a,b             ; Get exponent
        sub     8               ; Count 8 bits
        cp      -24-8           ; Was number zero?
        jp      nz,BNRMLP       ; No - Keep normalising
RESZER: xor     a               ; Result is zero
SAVEXP: ld      (FPEXP),a       ; Save result as zero
        ret

NORMAL: dec     b               ; Count bits
        add     hl,hl           ; Shift HL left
        ld      a,d             ; Get NMSB
        rla                     ; Shift left with last bit
        ld      d,a             ; Save NMSB
        ld      a,c             ; Get MSB
        adc     a,a             ; Shift left with last bit
        ld      c,a             ; Save MSB
PNORM:  jp      p,NORMAL        ; Not done - Keep going
        ld      a,b             ; Number of bits shifted
        ld      e,h             ; Save HL in EB
        ld      b,l
        or      a               ; Any shifting done?
        jp      z,RONDUP        ; No - Round it up
        ld      hl,FPEXP        ; Point to exponent
        add     a,(hl)          ; Add shifted bits
        ld      (hl),a          ; Re-save exponent
        jp      nc,RESZER       ; Underflow - Result is zero
        ret     z               ; Result is zero
RONDUP: ld      a,b             ; Get VLSB of number
RONDB:  ld      hl,FPEXP        ; Point to exponent
        or      a               ; Any rounding?
        call    m,FPROND        ; Yes - Round number up
        ld      b,(hl)          ; B = Exponent
        inc     hl
        ld      a,(hl)          ; Get sign of result
        and     %10000000       ; Only bit 7 needed
        xor     c               ; Set correct sign
        ld      c,a             ; Save correct sign in number
        jp      FPBCDE          ; Move BCDE to FPREG

FPROND: inc     e               ; Round LSB
        ret     nz              ; Return if ok
        inc     d               ; Round NMSB
        ret     nz              ; Return if ok
        inc     c               ; Round MSB
        ret     nz              ; Return if ok
        ld      c,$80           ; Set normal value
        inc     (hl)            ; Increment exponent
        ret     nz              ; Return if ok
        jp      OVERR           ; Overflow error

PLUCDE: ld      a,(hl)          ; Get LSB of FPREG
        add     a,e             ; Add LSB of BCDE
        ld      e,a             ; Save LSB of BCDE
        inc     hl
        ld      a,(hl)          ; Get NMSB of FPREG
        adc     a,d             ; Add NMSB of BCDE
        ld      d,a             ; Save NMSB of BCDE
        inc     hl
        ld      a,(hl)          ; Get MSB of FPREG
        adc     a,c             ; Add MSB of BCDE
        ld      c,a             ; Save MSB of BCDE
        ret

COMPL:  ld      hl,SGNRES       ; Sign of result
        ld      a,(hl)          ; Get sign of result
        cpl                     ; Negate it
        ld      (hl),a          ; Put it back
        xor     a
        ld      l,a             ; Set L to zero
        sub     b               ; Negate exponent,set carry
        ld      b,a             ; Re-save exponent
        ld      a,l             ; Load zero
        sbc     a,e             ; Negate LSB
        ld      e,a             ; Re-save LSB
        ld      a,l             ; Load zero
        sbc     a,d             ; Negate NMSB
        ld      d,a             ; Re-save NMSB
        ld      a,l             ; Load zero
        sbc     a,c             ; Negate MSB
        ld      c,a             ; Re-save MSB
        ret

SCALE:  ld      b,0             ; Clear underflow
SCALLP: sub     8               ; 8 bits (a whole byte)?
        jp      c,SHRITE        ; No - Shift right A bits
        ld      b,e             ; <- Shift
        ld      e,d             ; <- right
        ld      d,c             ; <- eight
        ld      c,0             ; <- bits
        jp      SCALLP          ; More bits to shift

SHRITE: add     a,8+1           ; Adjust count
        ld      l,a             ; Save bits to shift
SHRLP:  xor     a               ; Flag for all done
        dec     l               ; All shifting done?
        ret     z               ; Yes - Return
        ld      a,c             ; Get MSB
SHRT1:  rra                     ; Shift it right
        ld      c,a             ; Re-save
        ld      a,d             ; Get NMSB
        rra                     ; Shift right with last bit
        ld      d,a             ; Re-save it
        ld      a,e             ; Get LSB
        rra                     ; Shift right with last bit
        ld      e,a             ; Re-save it
        ld      a,b             ; Get underflow
        rra                     ; Shift right with last bit
        ld      b,a             ; Re-save underflow
        jp      SHRLP           ; More bits to do

UNITY:  db       $00,$00,$00,$81    ; 1.00000

LOGTAB: db      3                       ; Table used by LOG
        db      $AA,$56,$19,$80     ; 0.59898
        db      $F1,$22,$76,$80     ; 0.96147
        db      $45,$AA,$38,$82     ; 2.88539

flog:   call    TSTSGN          ; Test sign of value
        or      a
        jp      pe,FCERR        ; ?FC Error if <= zero
        ld      hl,FPEXP        ; Point to exponent
        ld      a,(hl)          ; Get exponent
        ld      bc,$8035        ; BCDE = SQR(1/2)
        ld      de,$04F3
        sub     b               ; Scale value to be < 1
        push    af              ; Save scale factor
        ld      (hl),b          ; Save new exponent
        push    de              ; Save SQR(1/2)
        push    bc
        call    FPADD           ; Add SQR(1/2) to value
        pop     bc              ; Restore SQR(1/2)
        pop     de
        inc     b               ; Make it SQR(2)
        call    DVBCDE          ; Divide by SQR(2)
        ld      hl,UNITY        ; Point to 1.
        call    SUBPHL          ; Subtract FPREG from 1
        ld      hl,LOGTAB       ; Coefficient table
        call    SUMSER          ; Evaluate sum of series
        ld      bc,$8080        ; BCDE = -0.5
        ld      de,$0000
        call    FPADD           ; Subtract 0.5 from FPREG
        pop     af              ; Restore scale factor
        call    RSCALE          ; Re-scale number
MULLN2: ld      bc,$8031        ; BCDE = Ln(2)
        ld      de,$7218
        db      $21             ; Skip "POP BC" and "POP DE"

MULT:   pop     bc              ; Get number from stack
        pop     de
FPMULT: call    TSTSGN          ; Test sign of FPREG
        ret     z               ; Return zero if zero
        ld      l,0             ; Flag add exponents
        call    ADDEXP          ; Add exponents
        ld      a,c             ; Get MSB of multiplier
        ld      (MULVAL),a      ; Save MSB of multiplier
        ex      de,hl
        ld      (MULVAL+1),hl   ; Save rest of multiplier
        ld      bc,0            ; Partial product (BCDE) = zero
        ld      d,b
        ld      e,b
        ld      hl,BNORM        ; Address of normalise
        push    hl              ; Save for return
        ld      hl,MULT8        ; Address of 8 bit multiply
        push    hl              ; Save for NMSB,MSB
        push    hl              ;
        ld      hl,FPREG        ; Point to number
MULT8:  ld      a,(hl)          ; Get LSB of number
        inc     hl              ; Point to NMSB
        or      a               ; Test LSB
        jp      z,BYTSFT        ; Zero - shift to next byte
        push    hl              ; Save address of number
        ld      l,8             ; 8 bits to multiply by
MUL8LP: rra                     ; Shift LSB right
        ld      h,a             ; Save LSB
        ld      a,c             ; Get MSB
        jp      nc,NOMADD       ; Bit was zero - Don't add
        push    hl              ; Save LSB and count
        ld      hl,(MULVAL+1)   ; Get LSB and NMSB
        add     hl,de           ; Add NMSB and LSB
        ex      de,hl           ; Leave sum in DE
        pop     hl              ; Restore MSB and count
        ld      a,(MULVAL)      ; Get MSB of multiplier
        adc     a,c             ; Add MSB
NOMADD: rra                     ; Shift MSB right
        ld      c,a             ; Re-save MSB
        ld      a,d             ; Get NMSB
        rra                     ; Shift NMSB right
        ld      d,a             ; Re-save NMSB
        ld      a,e             ; Get LSB
        rra                     ; Shift LSB right
        ld      e,a             ; Re-save LSB
        ld      a,b             ; Get VLSB
        rra                     ; Shift VLSB right
        ld      b,a             ; Re-save VLSB
        dec     l               ; Count bits multiplied
        ld      a,h             ; Get LSB of multiplier
        jp      nz,MUL8LP       ; More - Do it
POPHRT: pop     hl              ; Restore address of number
        ret

BYTSFT: ld      b,e             ; Shift partial product left
        ld      e,d
        ld      d,c
        ld      c,a
        ret

DIV10:  call    STAKFP          ; Save FPREG on stack
        ld      bc,$8420        ; BCDE = 10.
        ld      de,$0000
        call    FPBCDE          ; Move 10 to FPREG

DIV:    pop     bc              ; Get number from stack
        pop     de
DVBCDE: call    TSTSGN          ; Test sign of FPREG
        jp      z,DZERR         ; Error if division by zero
        ld      l,-1            ; Flag subtract exponents
        call    ADDEXP          ; Subtract exponents
        inc     (hl)            ; Add 2 to exponent to adjust
        inc     (hl)
        dec     hl              ; Point to MSB
        ld      a,(hl)          ; Get MSB of dividend
        ld      (DIV3),a        ; Save for subtraction
        dec     hl
        ld      a,(hl)          ; Get NMSB of dividend
        ld      (DIV2),a        ; Save for subtraction
        dec     hl
        ld      a,(hl)          ; Get MSB of dividend
        ld      (DIV1),a        ; Save for subtraction
        ld      b,c             ; Get MSB
        ex      de,hl           ; NMSB,LSB to HL
        xor     a
        ld      c,a             ; Clear MSB of quotient
        ld      d,a             ; Clear NMSB of quotient
        ld      e,a             ; Clear LSB of quotient
        ld      (DIV4),a        ; Clear overflow count
DIVLP:  push    hl              ; Save divisor
        push    bc
        ld      a,l             ; Get LSB of number
        call    DIVSUP          ; Subt' divisor from dividend
        sbc     a,0             ; Count for overflows
        ccf
        jp      nc,RESDIV       ; Restore divisor if borrow
        ld      (DIV4),a        ; Re-save overflow count
        pop     af              ; Scrap divisor
        pop     af
        scf                     ; Set carry to
        db      $D2            ; Skip "POP BC" and "POP HL"

RESDIV: pop     bc              ; Restore divisor
        pop     hl
        ld      a,c             ; Get MSB of quotient
        inc     a
        dec     a
        rra                     ; Bit 0 to bit 7
        jp      m,RONDB         ; Done - Normalise result
        rla                     ; Restore carry
        ld      a,e             ; Get LSB of quotient
        rla                     ; Double it
        ld      e,a             ; Put it back
        ld      a,d             ; Get NMSB of quotient
        rla                     ; Double it
        ld      d,a             ; Put it back
        ld      a,c             ; Get MSB of quotient
        rla                     ; Double it
        ld      c,a             ; Put it back
        add     hl,hl           ; Double NMSB,LSB of divisor
        ld      a,b             ; Get MSB of divisor
        rla                     ; Double it
        ld      b,a             ; Put it back
        ld      a,(DIV4)        ; Get VLSB of quotient
        rla                     ; Double it
        ld      (DIV4),a        ; Put it back
        ld      a,c             ; Get MSB of quotient
        or      d               ; Merge NMSB
        or      e               ; Merge LSB
        jp      nz,DIVLP        ; Not done - Keep dividing
        push    hl              ; Save divisor
        ld      hl,FPEXP        ; Point to exponent
        dec     (hl)            ; Divide by 2
        pop     hl              ; Restore divisor
        jp      nz,DIVLP        ; Ok - Keep going
        jp      OVERR           ; Overflow error

ADDEXP: ld      a,b             ; Get exponent of dividend
        or      a               ; Test it
        jp      z,OVTST3        ; Zero - Result zero
        ld      a,l             ; Get add/subtract flag
        ld      hl,FPEXP        ; Point to exponent
        xor     (hl)            ; Add or subtract it
        add     a,b             ; Add the other exponent
        ld      b,a             ; Save new exponent
        rra                     ; Test exponent for overflow
        xor     b
        ld      a,b             ; Get exponent
        jp      p,OVTST2        ; Positive - Test for overflow
        add     a,$80           ; Add excess 128
        ld      (hl),a          ; Save new exponent
        jp      z,POPHRT        ; Zero - Result zero
        call    SIGNS           ; Set MSBs and sign of result
        ld      (hl),a          ; Save new exponent
        dec     hl              ; Point to MSB
        ret

OVTST1: call    TSTSGN          ; Test sign of FPREG
        cpl                     ; Invert sign
        pop     hl              ; Clean up stack
OVTST2: or      a               ; Test if new exponent zero
OVTST3: pop     hl              ; Clear off return address
        jp      p,RESZER        ; Result zero
        jp      OVERR           ; Overflow error

MLSP10: call    BCDEFP          ; Move FPREG to BCDE
        ld      a,b             ; Get exponent
        or      a               ; Is it zero?
        ret     z               ; Yes - Result is zero
        add     a,2             ; Multiply by 4
        jp      c,OVERR         ; Overflow - ?OV Error
        ld      b,a             ; Re-save exponent
        call    FPADD           ; Add BCDE to FPREG (Times 5)
        ld      hl,FPEXP        ; Point to exponent
        inc     (hl)            ; Double number (Times 10)
        ret     nz              ; Ok - Return
        jp      OVERR           ; Overflow error

TSTSGN: ld      a,(FPEXP)       ; Get sign of FPREG
        or      a
        ret     z               ; RETurn if number is zero
        ld      a,(FPREG+2)     ; Get MSB of FPREG
        db      $FE            ; Test sign
RETREL: cpl                     ; Invert sign
        rla                     ; Sign bit to carry
FLGDIF: sbc     a,a             ; Carry to all bits of A
        ret     nz              ; Return -1 if negative
        inc     a               ; Bump to +1
        ret                     ; Positive - Return +1

SGN:    call    TSTSGN          ; Test sign of FPREG
FLGREL: ld      b,$80+8         ; 8 bit integer in exponent
        ld      de,0            ; Zero NMSB and LSB
RETINT: ld      hl,FPEXP        ; Point to exponent
        ld      c,a             ; CDE = MSB,NMSB and LSB
        ld      (hl),b          ; Save exponent
        ld      b,0             ; CDE = integer to normalise
        inc     hl              ; Point to sign of result
        ld      (hl),$80        ; Set sign of result
        rla                     ; Carry = sign of integer
        jp      CONPOS          ; Set sign of result

fabs:   call    TSTSGN          ; Test sign of FPREG
        ret     p               ; Return if positive
INVSGN: ld      hl,FPREG+2      ; Point to MSB
        ld      a,(hl)          ; Get sign of mantissa
        xor     $80             ; Invert sign of mantissa
        ld      (hl),a          ; Re-save sign of mantissa
        ret

STAKFP: ex      de,hl           ; Save code string address
        ld      hl,(FPREG)      ; LSB,NLSB of FPREG
        ex      (sp),hl         ; Stack them,get return
        push    hl              ; Re-save return
        ld      hl,(FPREG+2)    ; MSB and exponent of FPREG
        ex      (sp),hl         ; Stack them,get return
        push    hl              ; Re-save return
        ex      de,hl           ; Restore code string address
        ret

PHLTFP: call    LOADFP          ; Number at HL to BCDE
FPBCDE: ex      de,hl           ; Save code string address
        ld      (FPREG),hl      ; Save LSB,NLSB of number
        ld      h,b             ; Exponent of number
        ld      l,c             ; MSB of number
        ld      (FPREG+2),hl    ; Save MSB and exponent
        ex      de,hl           ; Restore code string address
        ret

BCDEFP: ld      hl,FPREG        ; Point to FPREG
LOADFP: ld      e,(hl)          ; Get LSB of number
        inc     hl
        ld      d,(hl)          ; Get NMSB of number
        inc     hl
        ld      c,(hl)          ; Get MSB of number
        inc     hl
        ld      b,(hl)          ; Get exponent of number
INCHL:  inc     hl              ; Used for conditional "INC HL"
        ret

FPTHL:  ld      de,FPREG        ; Point to FPREG
DETHL4: ld      b,4             ; 4 bytes to move
DETHLB: ld      a,(de)          ; Get source
        ld      (hl),a          ; Save destination
        inc     de              ; Next source
        inc     hl              ; Next destination
        dec     b               ; Count bytes
        jp      nz,DETHLB       ; Loop if more
        ret

SIGNS:  ld      hl,FPREG+2      ; Point to MSB of FPREG
        ld      a,(hl)          ; Get MSB
        rlca                    ; Old sign to carry
        scf                     ; Set MSBit
        rra                     ; Set MSBit of MSB
        ld      (hl),a          ; Save new MSB
        ccf                     ; Complement sign
        rra                     ; Old sign to carry
        inc     hl
        inc     hl
        ld      (hl),a          ; Set sign of result
        ld      a,c             ; Get MSB
        rlca                    ; Old sign to carry
        scf                     ; Set MSBit
        rra                     ; Set MSBit of MSB
        ld      c,a             ; Save MSB
        rra
        xor     (hl)            ; New sign of result
        ret

CMPNUM: ld      a,b             ; Get exponent of number
        or      a
        jp      z,TSTSGN        ; Zero - Test sign of FPREG
        ld      hl,RETREL       ; Return relation routine
        push    hl              ; Save for return
        call    TSTSGN          ; Test sign of FPREG
        ld      a,c             ; Get MSB of number
        ret     z               ; FPREG zero - Number's MSB
        ld      hl,FPREG+2      ; MSB of FPREG
        xor     (hl)            ; Combine signs
        ld      a,c             ; Get MSB of number
        ret     m               ; Exit if signs different
        call    CMPFP           ; Compare FP numbers
        rra                     ; Get carry to sign
        xor     c               ; Combine with MSB of number
        ret

CMPFP:  inc     hl              ; Point to exponent
        ld      a,b             ; Get exponent
        cp      (hl)            ; Compare exponents
        ret     nz              ; Different
        dec     hl              ; Point to MBS
        ld      a,c             ; Get MSB
        cp      (hl)            ; Compare MSBs
        ret     nz              ; Different
        dec     hl              ; Point to NMSB
        ld      a,d             ; Get NMSB
        cp      (hl)            ; Compare NMSBs
        ret     nz              ; Different
        dec     hl              ; Point to LSB
        ld      a,e             ; Get LSB
        sub     (hl)            ; Compare LSBs
        ret     nz              ; Different
        pop     hl              ; Drop RETurn
        pop     hl              ; Drop another RETurn
        ret

FPINT:  ld      b,a             ; <- Move
        ld      c,a             ; <- exponent
        ld      d,a             ; <- to all
        ld      e,a             ; <- bits
        or      a               ; Test exponent
        ret     z               ; Zero - Return zero
        push    hl              ; Save pointer to number
        call    BCDEFP          ; Move FPREG to BCDE
        call    SIGNS           ; Set MSBs & sign of result
        xor     (hl)            ; Combine with sign of FPREG
        ld      h,a             ; Save combined signs
        call    m,DCBCDE        ; Negative - Decrement BCDE
        ld      a,$80+24        ; 24 bits
        sub     b               ; Bits to shift
        call    SCALE           ; Shift BCDE
        ld      a,h             ; Get combined sign
        rla                     ; Sign to carry
        call    c,FPROND        ; Negative - Round number up
        ld      b,0             ; Zero exponent
        call    c,COMPL         ; If negative make positive
        pop     hl              ; Restore pointer to number
        ret

DCBCDE: dec     de              ; Decrement BCDE
        ld      a,d             ; Test LSBs
        and     e
        inc     a
        ret     nz              ; Exit if LSBs not FFFF
        dec     bc              ; Decrement MSBs
        ret

fint:   ld      hl,FPEXP        ; Point to exponent
        ld      a,(hl)          ; Get exponent
        cp      $80+24          ; Integer accuracy only?
        ld      a,(FPREG)       ; Get LSB
        ret     nc              ; Yes - Already integer
        ld      a,(hl)          ; Get exponent
        call    FPINT           ; F.P to integer
        ld      (hl),$80+24     ; Save 24 bit integer
        ld      a,e             ; Get LSB of number
        push    af              ; Save LSB
        ld      a,c             ; Get MSB of number
        rla                     ; Sign to carry
        call    CONPOS          ; Set sign of result
        pop     af              ; Restore LSB of number
        ret

MLDEBC: ld      hl,0            ; Clear partial product
        ld      a,b             ; Test multiplier
        or      c
        ret     z               ; Return zero if zero
        ld      a,16            ; 16 bits
MLDBLP: add     hl,hl           ; Shift P.P left
        jp      c,BSERR         ; ?BS Error if overflow
        ex      de,hl
        add     hl,hl           ; Shift multiplier left
        ex      de,hl
        jp      nc,NOMLAD       ; Bit was zero - No add
        add     hl,bc           ; Add multiplicand
        jp      c,BSERR         ; ?BS Error if overflow
NOMLAD: dec     a               ; Count bits
        jp      nz,MLDBLP       ; More
        ret

ASCTFP: cp      "-"             ; Negative?
        push    af              ; Save it and flags
        jp      z,CNVNUM        ; Yes - Convert number
        cp      "+"             ; Positive?
        jp      z,CNVNUM        ; Yes - Convert number
        dec     hl              ; DEC 'cos GETCHR INCs
CNVNUM: call    RESZER          ; Set result to zero
        ld      b,a             ; Digits after point counter
        ld      d,a             ; Sign of exponent
        ld      e,a             ; Exponent of ten
        cpl
        ld      c,a             ; Before or after point flag
MANLP:  call    GETCHR          ; Get next character
        jp      c,ADDIG         ; Digit - Add to number
        cp      "."
        jp      z,DPOINT        ; "." - Flag point
        cp      "E"
        jp      nz,CONEXP       ; Not "E" - Scale number
        call    GETCHR          ; Get next character
        call    SGNEXP          ; Get sign of exponent
EXPLP:  call    GETCHR          ; Get next character
        jp      c,EDIGIT        ; Digit - Add to exponent
        inc     d               ; Is sign negative?
        jp      nz,CONEXP       ; No - Scale number
        xor     a
        sub     e               ; Negate exponent
        ld      e,a             ; And re-save it
        inc     c               ; Flag end of number
DPOINT: inc     c               ; Flag point passed
        jp      z,MANLP         ; Zero - Get another digit
CONEXP: push    hl              ; Save code string address
        ld      a,e             ; Get exponent
        sub     b               ; Subtract digits after point
SCALMI: call    p,SCALPL        ; Positive - Multiply number
        jp      p,ENDCON        ; Positive - All done
        push    af              ; Save number of times to /10
        call    DIV10           ; Divide by 10
        pop     af              ; Restore count
        inc     a               ; Count divides

ENDCON: jp      nz,SCALMI       ; More to do
        pop     de              ; Restore code string address
        pop     af              ; Restore sign of number
        call    z,INVSGN        ; Negative - Negate number
        ex      de,hl           ; Code string address to HL
        ret

SCALPL: ret     z               ; Exit if no scaling needed
MULTEN: push    af              ; Save count
        call    MLSP10          ; Multiply number by 10
        pop     af              ; Restore count
        dec     a               ; Count multiplies
        ret

ADDIG:  push    de              ; Save sign of exponent
        ld      d,a             ; Save digit
        ld      a,b             ; Get digits after point
        adc     a,c             ; Add one if after point
        ld      b,a             ; Re-save counter
        push    bc              ; Save point flags
        push    hl              ; Save code string address
        push    de              ; Save digit
        call    MLSP10          ; Multiply number by 10
        pop     af              ; Restore digit
        sub     "0"             ; Make it absolute
        call    RSCALE          ; Re-scale number
        pop     hl              ; Restore code string address
        pop     bc              ; Restore point flags
        pop     de              ; Restore sign of exponent
        jp      MANLP           ; Get another digit

RSCALE: call    STAKFP          ; Put number on stack
        call    FLGREL          ; Digit to add to FPREG
PADD:   pop     bc              ; Restore number
        pop     de
        jp      FPADD           ; Add BCDE to FPREG and return

EDIGIT: ld      a,e             ; Get digit
        rlca                    ; Times 2
        rlca                    ; Times 4
        add     a,e             ; Times 5
        rlca                    ; Times 10
        add     a,(hl)          ; Add next digit
        sub     "0"             ; Make it absolute
        ld      e,a             ; Save new digit
        jp      EXPLP           ; Look for another digit

LINEIN: push    hl              ; Save code string address
        ld      hl,INMSG        ; Output " in "
        call    PRS             ; Output string at HL
        pop     hl              ; Restore code string address
PRNTHL: ex      de,hl           ; Code string address to DE
        xor     a
        ld      b,$80+24        ; 24 bits
        call    RETINT          ; Return the integer
        ld      hl,PRNUMS       ; Print number string
        push    hl              ; Save for return
NUMASC: ld      hl,PBUFF        ; Convert number to ASCII
        push    hl              ; Save for return
        call    TSTSGN          ; Test sign of FPREG
        ld      (hl)," "        ; Space at start
        jp      p,SPCFST        ; Positive - Space to start
        ld      (hl),"-"        ; "-" sign at start
SPCFST: inc     hl              ; First byte of number
        ld      (hl),"0"        ; "0" if zero
        jp      z,JSTZER        ; Return "0" if zero
        push    hl              ; Save buffer address
        call    m,INVSGN        ; Negate FPREG if negative
        xor     a               ; Zero A
        push    af              ; Save it
        call    RNGTST          ; Test number is in range
SIXDIG: ld      bc,$9143        ; BCDE - 99999.9
        ld      de,$4FF8
        call    CMPNUM          ; Compare numbers
        or      a
        jp      po,INRNG        ; > 99999.9 - Sort it out
        pop     af              ; Restore count
        call    MULTEN          ; Multiply by ten
        push    af              ; Re-save count
        jp      SIXDIG          ; Test it again

GTSIXD: call    DIV10           ; Divide by 10
        pop     af              ; Get count
        inc     a               ; Count divides
        push    af              ; Re-save count
        call    RNGTST          ; Test number is in range
INRNG:  call    fround          ; Add 0.5 to FPREG
        inc     a
        call    FPINT           ; F.P to integer
        call    FPBCDE          ; Move BCDE to FPREG
        ld      bc,$0306        ; 1E+06 to 1E-03 range
        pop     af              ; Restore count
        add     a,c             ; 6 digits before point
        inc     a               ; Add one
        jp      m,MAKNUM        ; Do it in "E" form if < 1E-02
        cp      6+1+1           ; More than 999999 ?
        jp      nc,MAKNUM       ; Yes - Do it in "E" form
        inc     a               ; Adjust for exponent
        ld      b,a             ; Exponent of number
        ld      a,2             ; Make it zero after

MAKNUM: dec     a               ; Adjust for digits to do
        dec     a
        pop     hl              ; Restore buffer address
        push    af              ; Save count
        ld      de,POWERS       ; Powers of ten
        dec     b               ; Count digits before point
        jp      nz,DIGTXT       ; Not zero - Do number
        ld      (hl),"."        ; Save point
        inc     hl              ; Move on
        ld      (hl),"0"        ; Save zero
        inc     hl              ; Move on
DIGTXT: dec     b               ; Count digits before point
        ld      (hl),"."        ; Save point in case
        call    z,INCHL         ; Last digit - move on
        push    bc              ; Save digits before point
        push    hl              ; Save buffer address
        push    de              ; Save powers of ten
        call    BCDEFP          ; Move FPREG to BCDE
        pop     hl              ; Powers of ten table
        ld      b, "0"-1        ; ASCII "0" - 1
TRYAGN: inc     b               ; Count subtractions
        ld      a,e             ; Get LSB
        sub     (hl)            ; Subtract LSB
        ld      e,a             ; Save LSB
        inc     hl
        ld      a,d             ; Get NMSB
        sbc     a,(hl)          ; Subtract NMSB
        ld      d,a             ; Save NMSB
        inc     hl
        ld      a,c             ; Get MSB
        sbc     a,(hl)          ; Subtract MSB
        ld      c,a             ; Save MSB
        dec     hl              ; Point back to start
        dec     hl
        jp      nc,TRYAGN       ; No overflow - Try again
        call    PLUCDE          ; Restore number
        inc     hl              ; Start of next number
        call    FPBCDE          ; Move BCDE to FPREG
        ex      de,hl           ; Save point in table
        pop     hl              ; Restore buffer address
        ld      (hl),b          ; Save digit in buffer
        inc     hl              ; And move on
        pop     bc              ; Restore digit count
        dec     c               ; Count digits
        jp      nz,DIGTXT       ; More - Do them
        dec     b               ; Any decimal part?
        jp      z,DOEBIT        ; No - Do "E" bit
SUPTLZ: dec     hl              ; Move back through buffer
        ld      a,(hl)          ; Get character
        cp      "0"             ; "0" character?
        jp      z,SUPTLZ        ; Yes - Look back for more
        cp      "."             ; A decimal point?
        call    nz,INCHL        ; Move back over digit

DOEBIT: pop     af              ; Get "E" flag
        jp      z,NOENED        ; No "E" needed - End buffer
        ld      (hl),"E"        ; Put "E" in buffer
        inc     hl              ; And move on
        ld      (hl),"+"        ; Put '+' in buffer
        jp      p,OUTEXP        ; Positive - Output exponent
        ld      (hl),"-"        ; Put "-" in buffer
        cpl                     ; Negate exponent
        inc     a
OUTEXP: ld      b,"0"-1         ; ASCII "0" - 1
EXPTEN: inc     b               ; Count subtractions
        sub     10              ; Tens digit
        jp      nc,EXPTEN       ; More to do
        add     a,"0"+10        ; Restore and make ASCII
        inc     hl              ; Move on
        ld      (hl),b          ; Save MSB of exponent
JSTZER: inc     hl              ;
        ld      (hl),a          ; Save LSB of exponent
        inc     hl
NOENED: ld      (hl),c          ; Mark end of buffer
        pop     hl              ; Restore code string address
        ret

RNGTST: ld      bc,$9474        ; BCDE = 999999.
        ld      de,$23F7
        call    CMPNUM          ; Compare numbers
        or      a
        pop     hl              ; Return address to HL
        jp      po,GTSIXD       ; Too big - Divide by ten
        jp      (hl)            ; Otherwise return to caller

HALF:   db      $00,$00,$00,$80 ; 0.5

POWERS: db      $A0,$86,$01  ; 100000
        db      $10,$27,$00  ;  10000
        db      $E8,$03,$00  ;   1000
        db      $64,$00,$00  ;    100
        db      $0A,$00,$00  ;     10
        db      $01,$00,$00  ;      1

NEGAFT: ld  hl,INVSGN           ; Negate result
        ex      (sp),hl         ; To be done after caller
        jp      (hl)            ; Return to caller

SQR:    call    STAKFP          ; Put value on stack
        ld      hl,HALF         ; Set power to 1/2
        call    PHLTFP          ; Move 1/2 to FPREG

POWER:  pop     bc              ; Get base
        pop     de
        call    TSTSGN          ; Test sign of power
        ld      a,b             ; Get exponent of base
        jp      z,fexp          ; Make result 1 if zero
        jp      p,POWER1        ; Positive base - Ok
        or      a               ; Zero to negative power?
        jp      z,DZERR         ; Yes - ?/0 Error
POWER1: or      a               ; Base zero?
        jp      z,SAVEXP        ; Yes - Return zero
        push    de              ; Save base
        push    bc
        ld      a,c             ; Get MSB of base
        or      %01111111       ; Get sign status
        call    BCDEFP          ; Move power to BCDE
        jp      p,POWER2        ; Positive base - Ok
        push    de              ; Save power
        push    bc
        call    fint            ; Get integer of power
        pop     bc              ; Restore power
        pop     de
        push    af              ; MSB of base
        call    CMPNUM          ; Power an integer?
        pop     hl              ; Restore MSB of base
        ld      a,h             ; but don't affect flags
        rra                     ; Exponent odd or even?
POWER2: pop     hl              ; Restore MSB and exponent
        ld      (FPREG+2),hl    ; Save base in FPREG
        pop     hl              ; LSBs of base
        ld      (FPREG),hl      ; Save in FPREG
        call    c,NEGAFT        ; Odd power - Negate result
        call    z,INVSGN        ; Negative base - Negate it
        push    de              ; Save power
        push    bc
        call    flog            ; Get LOG of base
        pop     bc              ; Restore power
        pop     de
        call    FPMULT          ; Multiply LOG by power

fexp:   call    STAKFP          ; Put value on stack
        ld      bc,$8138       ; BCDE = 1/Ln(2)
        ld      de,$AA3B
        call    FPMULT          ; Multiply value by 1/LN(2)
        ld      a,(FPEXP)       ; Get exponent
        cp      $80+8           ; Is it in range?
        jp      nc,OVTST1       ; No - Test for overflow
        call    fint            ; Get INT of FPREG
        add     a,$80           ; For excess 128
        add     a,2             ; Exponent > 126?
        jp      c,OVTST1        ; Yes - Test for overflow
        push    af              ; Save scaling factor
        ld      hl,UNITY        ; Point to 1.
        call    ADDPHL          ; Add 1 to FPREG
        call    MULLN2          ; Multiply by LN(2)
        pop     af              ; Restore scaling factor
        pop     bc              ; Restore exponent
        pop     de
        push    af              ; Save scaling factor
        call    SUBCDE          ; Subtract exponent from FPREG
        call    INVSGN          ; Negate result
        ld      hl,EXPTAB       ; Coefficient table
        call    SMSER1          ; Sum the series
        ld      de,0            ; Zero LSBs
        pop     bc              ; Scaling factor
        ld      c,d             ; Zero MSB
        jp      FPMULT          ; Scale result to correct value

EXPTAB: db      8                       ; Table used by EXP
        db      $40,$2E,$94,$74     ; -1/7! (-1/5040)
        db      $70,$4F,$2E,$77     ;  1/6! ( 1/720)
        db      $6E,$02,$88,$7A     ; -1/5! (-1/120)
        db      $E6,$A0,$2A,$7C     ;  1/4! ( 1/24)
        db      $50,$AA,$AA,$7E     ; -1/3! (-1/6)
        db      $FF,$FF,$7F,$7F     ;  1/2! ( 1/2)
        db      $00,$00,$80,$81     ; -1/1! (-1/1)
        db      $00,$00,$00,$81     ;  1/0! ( 1/1)

SUMSER: call    STAKFP          ; Put FPREG on stack
        ld      de,MULT         ; Multiply by "X"
        push    de              ; To be done after
        push    hl              ; Save address of table
        call    BCDEFP          ; Move FPREG to BCDE
        call    FPMULT          ; Square the value
        pop     hl              ; Restore address of table
SMSER1: call    STAKFP          ; Put value on stack
        ld      a,(hl)          ; Get number of coefficients
        inc     hl              ; Point to start of table
        call    PHLTFP          ; Move coefficient to FPREG
        db      $06             ; Skip "POP AF"
SUMLP:  pop     af              ; Restore count
        pop     bc              ; Restore number
        pop     de
        dec     a               ; Cont coefficients
        ret     z               ; All done
        push    de              ; Save number
        push    bc
        push    af              ; Save count
        push    hl              ; Save address in table
        call    FPMULT          ; Multiply FPREG by BCDE
        pop     hl              ; Restore address in table
        call    LOADFP          ; Number at HL to BCDE
        push    hl              ; Save address in table
        call    FPADD           ; Add coefficient to FPREG
        pop     hl              ; Restore address in table
        jp      SUMLP           ; More coefficients

RND:    call    TSTSGN          ; Test sign of FPREG
        ld      hl,SEED+2       ; Random number seed
        jp      m,RESEED        ; Negative - Re-seed
        ld      hl,LSTRND       ; Last random number
        call    PHLTFP          ; Move last RND to FPREG
        ld      hl,SEED+2       ; Random number seed
        ret     z               ; Return if RND(0)
        add     a,(hl)          ; Add (SEED)+2)
        and     %00000111       ; 0 to 7
        ld      b,0
        ld      (hl),a          ; Re-save seed
        inc     hl              ; Move to coefficient table
        add     a,a             ; 4 bytes
        add     a,a             ; per entry
        ld      c,a             ; BC = Offset into table
        add     hl,bc           ; Point to coefficient
        call    LOADFP          ; Coefficient to BCDE
        call    FPMULT  ;       ; Multiply FPREG by coefficient
        ld      a,(SEED+1)      ; Get (SEED+1)
        inc     a               ; Add 1
        and     %00000011       ; 0 to 3
        ld      b,0
        cp      1               ; Is it zero?
        adc     a,b             ; Yes - Make it 1
        ld      (SEED+1),a      ; Re-save seed
        ld      hl,RNDTAB-4     ; Addition table
        add     a,a             ; 4 bytes
        add     a,a             ; per entry
        ld      c,a             ; BC = Offset into table
        add     hl,bc           ; Point to value
        call    ADDPHL          ; Add value to FPREG
RND1:   call    BCDEFP          ; Move FPREG to BCDE
        ld      a,e             ; Get LSB
        ld      e,c             ; LSB = MSB
        xor     %01001111       ; Fiddle around
        ld      c,a             ; New MSB
        ld      (hl),$80        ; Set exponent
        dec     hl              ; Point to MSB
        ld      b,(hl)          ; Get MSB
        ld      (hl),$80        ; Make value -0.5
        ld      hl,SEED         ; Random number seed
        inc     (hl)            ; Count seed
        ld      a,(hl)          ; Get seed
        sub     171             ; Do it modulo 171
        jp      nz,RND2         ; Non-zero - Ok
        ld      (hl),a          ; Zero seed
        inc     c               ; Fillde about
        dec     d               ; with the
        inc     e               ; number
RND2:   call    BNORM           ; Normalise number
        ld      hl,LSTRND       ; Save random number
        jp      FPTHL           ; Move FPREG to last and return

RESEED: ld      (hl),a          ; Re-seed random numbers
        dec     hl
        ld      (hl),a
        dec     hl
        ld      (hl),a
        jp      RND1            ; Return RND seed

RNDTAB: db      $68,$B1,$46,$68     ; Table used by RND
        db      $99,$E9,$92,$69
        db      $10,$D1,$75,$68

fcos:   ld      hl,HALFPI       ; Point to PI/2
        call    ADDPHL          ; Add it to PPREG
fsin:   call    STAKFP          ; Put angle on stack
        ld      bc,$8349        ; BCDE = 2 PI
        ld      de,$0FDB
        call    FPBCDE          ; Move 2 PI to FPREG
        pop     bc              ; Restore angle
        pop     de
        call    DVBCDE          ; Divide angle by 2 PI
        call    STAKFP          ; Put it on stack
        call    fint            ; Get INT of result
        pop     bc              ; Restore number
        pop     de
        call    SUBCDE          ; Make it 0 <= value < 1
        ld      hl,QUARTR       ; Point to 0.25
        call    SUBPHL          ; Subtract value from 0.25
        call    TSTSGN          ; Test sign of value
        scf                     ; Flag positive
        jp      p,SIN1          ; Positive - Ok
        call    fround          ; Add 0.5 to value
        call    TSTSGN          ; Test sign of value
        or      a               ; Flag negative
SIN1:   push    af              ; Save sign
        call    p,INVSGN        ; Negate value if positive
        ld      hl,QUARTR       ; Point to 0.25
        call    ADDPHL          ; Add 0.25 to value
        pop     af              ; Restore sign
        call    nc,INVSGN       ; Negative - Make positive
        ld      hl,SINTAB       ; Coefficient table
        jp      SUMSER          ; Evaluate sum of series

HALFPI: db      $DB,$0F,$49,$81     ; 1.5708 (PI/2)

QUARTR: db      $00,$00,$00,$7F     ; 0.25

SINTAB: db      5                       ; Table used by SIN
        db      $BA,$D7,$1E,$86     ; 39.711
        db      $64,$26,$99,$87     ;-76.575
        db      $58,$34,$23,$87     ; 81.602
        db      $E0,$5D,$A5,$86     ;-41.342
        db      $DA,$0F,$49,$83     ;  6.2832

ftan:   call    STAKFP          ; Put angle on stack
        call    fsin            ; Get SIN of angle
        pop     bc              ; Restore angle
        pop     hl
        call    STAKFP          ; Save SIN of angle
        ex      de,hl           ; BCDE = Angle
        call    FPBCDE          ; Angle to FPREG
        call    fcos            ; Get COS of angle
        jp      DIV             ; TAN = SIN / COS

ATN:    call    TSTSGN          ; Test sign of value
        call    m,NEGAFT        ; Negate result after if -ve
        call    m,INVSGN        ; Negate value if -ve
        ld      a,(FPEXP)       ; Get exponent
        cp      $81             ; Number less than 1?
        jp      c,ATN1          ; Yes - Get arc tangnt
        ld      bc,$8100        ; BCDE = 1
        ld      d,c
        ld      e,c
        call    DVBCDE          ; Get reciprocal of number
        ld      hl,SUBPHL       ; Sub angle from PI/2
        push    hl              ; Save for angle > 1
ATN1:   ld      hl,ATNTAB       ; Coefficient table
        call    SUMSER          ; Evaluate sum of series
        ld      hl,HALFPI       ; PI/2 - angle in case > 1
        ret                     ; Number > 1 - Sub from PI/2

ATNTAB: db      9                       ; Table used by ATN
        db      $4A,$D7,$3B,$78     ; 1/17
        db      $02,$6E,$84,$7B     ;-1/15
        db      $FE,$C1,$2F,$7C     ; 1/13
        db      $74,$31,$9A,$7D     ;-1/11
        db      $84,$3D,$5A,$7D     ; 1/9
        db      $C8,$7F,$91,$7E     ;-1/7
        db      $E4,$BB,$4C,$7E     ; 1/5
        db      $6C,$AA,$AA,$7F     ;-1/3
        db      $00,$00,$00,$81     ; 1/1

CASFFW: call    FLPLED          ; Turn on cassette
        ld      b,0             ; Set 1 second delay
DELAYB: call    DELAY           ; Wait a bit
        dec     b               ; Count
        jp      nz,DELAYB       ; More delay needed
        ret

CASFF:  jp      FLPLED          ; Flip tape LED

ARET:   ret                     ; A RETurn instruction

CONMON: push    hl              ; Output character to screen
        push    bc              ;
        push    de              ;
        push    af              ;
        call    MONTST          ; See if NAS-SYS
        jp      nz,NASOUT       ; NAS-SYS - Output ASCII
        pop     af              ; Get character
        push    af              ; And re-save
        cp      LF              ; ASCII Line feed?
        jp      z,IGCHR         ; Yes - Ignore it
        cp      BKSP            ; ASCII back space?
        jp      nz,CONOT1       ; No - Test for CR
        ld      a,TBS           ; NASBUG back space
CONOT1: cp      CR              ; ASCII CR?
        jp      nz,OUTCHR       ; No - Output character
        ld      a,TCR           ; NASBUG CR
        jp      OUTCHR          ; Output it

NASOUT: pop     af              ; Get character
        push    af              ; And re-save
OUTCHR: call    MONOUT          ; Output it
IGCHR:  pop     af              ; Restore character
        pop     de              ;
        pop     bc              ;
        pop     hl              ;
        ret

GETINP: push    hl              ; Get an input character
        push    bc              ;
        push    de              ;
        call    MONTST          ; See if NAS-SYS
        jp      z,GETTIN        ; "T" monitor - Get input
        dw      _BLNK
        jp      CONVIN          ; Convert to ASCII

GETTIN: call    TIN             ; "T" input a character
        jp      nc,GETTIN       ; No input - wait
CONVIN: cp      TBS             ; NASBUG back space?
        jp      nz,CNVIN1       ; No - Test for break
        ld      a,BKSP          ; ASCII back space
CNVIN1: cp      TBRK            ; NASBUG break?
        jp      nz,CNVIN2       ; No - Test for control Z
        ld      a,CTRLC         ; Control C
CNVIN2: cp      CTRLZ           ; ^Z?
        jp      nz,CNVIN3       ; No - Test for escape
        ld      a,DEL           ; Delete
CNVIN3: cp      ESC             ; "ESC" ?
        jp      nz,CNVIN4       ; No - Test for CR
        ld      a,CTRLC         ; Control C
CNVIN4: cp      TCR             ; NASBUG CR?
        jp      nz,CNVIN5       ; No - Return character
        ld      a,CR            ; ASCII CR
CNVIN5: pop     de
        pop     bc
        pop     hl
        ret

CHKBRK: xor     a               ; Check for break
        call    SFTENT          ; Test for shift/enter
        jp      z,TBRK2         ; Yes - Test for second break
        ld      a,(BRKFLG)      ; Get break flag
        or      a               ; Break flag set?
        jp      nz,TBRK2        ; Yes - Test for second break
        xor     a               ; Flag no break
        ret

TBRK2:  call    BREAK2          ; Second break?
        ld      a,-1            ; Flag break
        ret

GUART:  in      a,(UARTS)       ; Get UART status
        rla                     ; Any data ready?
        jp      nc,GUART        ; No - wait until there is
        in      a,(UARTD)       ; Get data from UART
        ret

UARTOT: out     (UARTD),a       ; Send data to UART
URTOLP: in      a,(UARTS)       ; Get status
        add     a,a             ; Byte sent?
        ret     m               ; Yes - Return
        jp      URTOLP          ; Keep waiting

SUART:  push    af              ; Save A
        call    UARTOT          ; Send it to UART
        pop     af              ; Restore A
        ret

        nop
        nop

SFTENT: push    hl              ; Test for Shift Enter from KBD
        ld      a,%00000010     ; Reset KBD counter mask
        ld      hl,PORT0        ; Get old contents
        xor     (hl)            ; Toggle bit
        out     (0),a           ; Reset KBD counter
        xor     %00000001       ; Toggle bit
        out     (0),a           ; Next row
        xor     %00000010
        out     (0),a           ; Clear "clear" strobe
        ld      a,(hl)          ; Get old value
        out     (0),a           ; Original contents
        add     hl,de           ; ?? WHAT ??
        pop     hl              ; Restore HL
        in      a,(0)           ; Read in row
        and     %00010010       ; Mask SHIFT and ENTER
        ret

CLS:    call    MONTST          ; See if NAS-SYS
        jp      z,TCLS          ; "T" CLS
        ld      a,CS            ; ASCII Clear screen
        jp      CONMON          ; Output character

TCLS:   ld      a,TCS           ; NASBUG Clear screen
        jp      CONMON          ; Output character

DELAY:  xor     a               ; Delay routine
DELAY1: push    af              ; PUSHes and POPs delay
        pop     af
        push    af
        pop     af
        dec     a               ; Count delays
        jp      nz,DELAY1       ; More delay
        ret

WIDTH:  call    GETINT          ; Get integer 0-255
        ld      a,e             ; Width to A
        ld      (LWIDTH),a      ; Set width
        ret

LINES:  call    GETNUM          ; Get a number
        call    DEINT           ; Get integer -32768 to 32767
        ld      (LINESC),de     ; Set lines counter
        ld      (LINESN),de     ; Set lines number
        ret

DEEK:   call    DEINT           ; Get integer -32768 to 32767
        push    de              ; Save number
        pop     hl              ; Number to HL
        ld      b,(hl)          ; Get LSB of contents
        inc     hl
        ld      a,(hl)          ; Get MSB of contents
        jp      ABPASS          ; Return integer AB

DOKE:   call    GETNUM          ; Get a number
        call    DEINT           ; Get integer -32768 to 32767
        push    de              ; Save address
        call    CHKSYN          ; Make sure "," follows
        db      ","
        call    GETNUM          ; Get a number
        call    DEINT           ; Get integer -32768 to 32767
        ex      (sp),hl         ; Save value,get address
        ld      (hl),e          ; Save LSB of value
        inc     hl
        ld      (hl),d          ; Save MSB of value
        pop     hl              ; Restore code string address
        ret

JJUMP1: di                      ; Disable interrupts
        ld      ix,-1           ; Flag cold start
        jp      CSTART          ; Go and initialise

SCREEN: call    GETINT          ; Get integer 0 to 255
        push    af              ; Save column
        call    CHKSYN          ; Make sure "," follows
        db      ","
        call    GETINT          ; Get integer 0 to 255
        pop     bc              ; Column to B
        push    hl              ; Save code string address
        push    bc              ; Save column
        call    SCRADR          ; Calculate screen address
        push    hl              ; Save screen address
        call    MONTST          ; See if NAS-SYS
        jp      z,TMNCUR        ; "T" monitor - "T" cursor
        pop     hl              ; Restore screen address
        ld      (CURSOR),hl     ; Set new cursor position
        pop     hl              ; Rstore code string address
        ret

TMNCUR: ld      hl,(TCUR)       ; Get address or cursor
        ld      (hl)," "        ; Remove cursor
        pop     hl              ; Get new cursor address
        ld      (TCUR),hl       ; Set new cursor
        ld      (hl),"_"        ; Put it on screen
        pop     hl              ; Restore code string address
        ret

SCRADR: ld      hl,VDU+10-65    ; SCREEN VDU address (0,0)
        ld      b,0
        ld      c,a             ; Line to BC
        or      a               ; Test it
        jp      z,FCERR         ; Zero - ?FC Error
        cp      16+1            ; 16 lines
        jp      p,FCERR         ; > 16 - ?FC Error
        pop     de              ; RETurn address
        pop     af              ; Get column
        push    de              ; Re-save RETurn
        ld      d,0
        ld      e,a             ; Column to DE
        or      a               ; Test it
        jp      z,FCERR         ; Zero - ?FC Error
        cp      48+1            ; 48 characters per line
        jp      p,FCERR         ; > 48 - ?FC Error
        add     hl,de           ; Add column to address
        ld      d,0
        ld      e,c             ; Line to DE
        ld      b,64            ; 64 Bytes per line
ADD64X: add     hl,de           ; Add line
        djnz    ADD64X          ; SIXTY FOUR TIMES!!!
        ret

FLPLED: call    MONTST          ; See if NAS-SYS
        jp      z,TMFLP         ; "T" MFLP
        dw      _MFLP
        ret

TMFLP:  jp      MFLP            ; Flip drive LED

MONOUT: push    af              ; Save character
        call    MONTST          ; See if NAS-SYS
        jp      z,TMNOUT        ; "T" output
        pop     af              ; Restore character
        db      _ROUT           ; Output it
        ret

TMNOUT: pop     af              ; Restore character
        jp      TOUT            ; "T" output

BREAK2: ld      a,(BRKFLG)      ; Break flag set?
        jp      nz,RETCTC       ; Yes - Return ^C
        call    MONTST          ; See if NAS-SYS
        jp      z,TCHINP        ; Get "T" character input
        dw      _RIN            ; Scan for a character
        ret

TCHINP: jp      TIN             ; "T" input a character

RETCTC: ld      a,0             ; Clear Break flag
        ld      (BRKFLG),a
        ld      a,CTRLC         ; Return ^C
        ret

MONTST: ld      a,(MONSTT+1)    ; "T" monitor or NAS-SYS?
        cp      $33             ; 31 00 10 / 31 33 0C
        ret

SAVE:   call    FLPLED          ; Flip tape LED
        call    MONTST          ; See if NAS-SYS
        jp      z,TSAVE         ; "T" save
        dw      _WRIT           ; Save program
        ret

TSAVE:  ld      a,(MONTYP)      ; "T2" or "T4" (FLAGS!!!)
        jp      z,T4WR          ; T4 Write
        jp      T2DUMP          ; T2 Dump

MONLD:  call    FLPLED          ; Flip tape LED
        call    MONTST          ; See if NAS-SYS
        jp      z,TLOAD         ; "T" load
        ld      a,"R"           ; Set READ
        ld      (ARGN),a
        dw      _READ           ; Load program
        ret

TLOAD:  ld      a,(MONTYP)      ; "T2" or "T4" (FLAGS!!!)
        jp      z,T4READ        ; T4 Read
        jp      T2DUMP          ; T2 Dump ??????????

MONITR: call    MONTST          ; See if NAS-SYS
        jp      z,MONSTT        ; Jump to zero if "T"
        dw      _MRET           ; Return to NAS-SYS

MONVE:  call    FLPLED          ; Flip tape LED
        call    MONTST          ; See if NAS-SYS
        jp      z,FCERR         ; Verify not available on "T"
        ld      a,"V"           ; Set VERIFY
        ld      (ARGN),a
        dw      _VRFY           ; Verify tape
        ret

INITST: ld      a,0             ; Clear break flag
        ld      (BRKFLG),a
        call    MONTST          ; See if NAS-SYS
        jp      z,INIT          ; "T" - No NMI vector
        ld      hl,BREAK        ; Set NMI gives break
        ld      (NMI),hl
        push    ix              ; Get start up condition
        pop     af              ; "Z" set if cold , Else clear
        or      a               ; "Cold" or "Cool" start?
        jp      nz,INIT         ; "Cool" don't init NAS-SYS
        ld      b,15            ; Delay for keyboard clear
        call    DELAYB          ; Allow time for key release
        call    STMON           ; Initialise NAS-SYS
        jp      INIT            ; Initialise BASIC

BREAK:  push    af              ; Save character
        ld      a,-1
        ld      (BRKFLG),a      ; Flag break
        pop     af              ; Restore character
ARETN:  retn                    ; Return from NMI

        nop

INLINE: dw      _INLN           ; Get an input line
        push    de              ; Save cursor address
        push    de              ; Cursor address to HL
        pop     hl
        ld      de,48-1         ; Length of line-1
        add     hl,de           ; Point to end of line
ENDLIN: ld      a,(hl)          ; Get end of line
        cp      " "             ; Space?
        jp      nz,LINTBF       ; No - Copy to buffer
        dec     e               ; Back 1 character
        ld      a,0             ; Wasteful test on E
        or      e
        jp      z,LINTBF        ; Start of line - Copy it
        dec     hl              ; Back 1 character
        jp      ENDLIN          ; Keep looking for end

LINTBF: push    de              ; Line length to BC
        pop     bc
        inc     bc              ; Length +1
        ld      de,BUFFER       ; Input buffer
        pop     hl              ; Line start
        push    bc              ; Save length
        ldir                    ; Move line to buffer
        ld      a,0
        ld      (de),a          ; Mark end of buffer with 00
        pop     bc              ; Restore buffer length
        ld      b,c             ; Length returned in B
        ld      hl,BUFFER-1     ; Point to start of buffer-1
        ret

GETXYA: call    CHKSYN          ; Make sure "(" follows
        db      "("
        call    GETNUM          ; Get a number
        call    DEINT           ; Get integer -32768 to 32767
        push    de              ; Save "X"
        call    CHKSYN          ; Make sure "," follows
        db      ","
        call    GETNUM          ; Get a number
        call    CHKSYN          ; Make sure ")" follows
        db      ")"
        call    DEINT           ; Get integer -32768 to 32767
        push    hl              ; Save code string address
        pop     iy              ; In IY
        call    XYPOS           ; Address and bit mask
        push    af              ; Save mask
        call    ADJCOL          ; Adjust column
        call    SCRADR          ; Get VDU address
        pop     af              ; Restore bit mask
        ld      b,%11000000     ; Block graphics base
        or      b               ; Set bits 7 & 6
        ret

SETB:   call    GETXYA          ; Get co-ords and VDU address
        push    af              ; Save bit mask
        ld      a,(hl)          ; Get character from screen
        cp      %11000000       ; Is it a block graphic?
        jp      nc,SETOR        ; Yes - OR new bit
        pop     af              ; Restore bit mask
PUTBIT: ld      (hl),a          ; Put character on screen
RESCSA: push    iy              ; Restore code string address
        pop     hl              ; From IY
        ret

SETOR:  pop     bc              ; Restore bit mask
        or      b               ; Merge the bits
        jp      PUTBIT          ; Save on screen

RESETB: call    GETXYA          ; Get co-ords and VDU address
        push    af              ; Save bit mask
        ld      a,(hl)          ; Get byte from screen
        cp      %11000000       ; Is it a block graphic?
        jp      c,NORES         ; No - Leave it
        ld      b,%00111111     ; Six bits per block
        and     b               ; Clear bits 7 & 6
        pop     bc              ; Get bit mask
        and     b               ; Test for common bit
        jp      z,RESCSA        ; None - Leave it
        ld      a,(hl)          ; Get byte from screen
        and     %00111111       ; Isolate bit
        xor     b               ; Clear that bit
        cp      %11000000       ; Is it a graphic blank?
        jp      nz,PUTBIT       ; No - Save character
        ld      a," "           ; Put a space there
        jp      PUTBIT          ; Save the space

NORES:  pop     bc              ; Drop bit mask
        jp      RESCSA          ; Restore code string address

POINTB: call    GETXYA          ; Get co-ords and VDU address
        ld      b,(hl)          ; Get character from screen
        call    TSTBIT          ; Test if bit is set
        jp      nz,POINT0       ; Different - Return zero
        ld      a,0
        ld      b,1             ; Integer AB = 1
POINTX: pop     hl              ; Drop return
        push    iy              ; PUSH code string address
        ld      de,RETNUM       ; To return a number
        push    de              ; Save for return
        jp      ABPASS          ; Return integer AB

POINT0: ld      b,0             ; Set zero
        jp      POINTX          ; Return value

XYPOS:  pop     bc              ; Get return address
        pop     hl              ; Get column
        push    hl              ; And re-save
        push    bc              ; Put back return address
        ld      a,l             ; Get column
        ld      b,%00000001     ; 2 bits per character
        and     b               ; Odd or even bit
        push    af              ; Save it
        push    de              ; Get row
        pop     hl              ; to HL
        ld      de,0            ; Zero line count
        ld      bc,3            ; 3 blocks per line
        inc     hl
DIV3LP: sbc     hl,bc           ; Subtract 3
        inc     de              ; Count the subtractions
        jp      z,DIV3EX        ; Exactly - Exit
        jp      p,DIV3LP        ; More to do

DIV3EX: add     hl,bc           ; Restore number
        pop     af              ; Restore column and odd/even
        or      a               ; Set flags (NZ or Z)
        ld      a,l             ; Get remainder from /3
        jp      z,NOREMD        ; No remainder
        add     a,3             ; Adjust remainder
NOREMD: ld      b,a             ; Bit number+1 to B
        ld      a,%00000001     ; Bit to rotate
SHFTBT: rlca                    ; Shift bit left
        djnz    SHFTBT          ; Count shifts
        rra                     ; Restore correct place
        ret

ADJCOL: pop     bc              ; Restore return address
        pop     af              ; Get bit mask
        pop     hl              ; Get column
        push    af              ; Re-save but mask
        ld      a,l             ; Get column
        rra                     ; Divide by 2
        add     a,1             ; Start at column 1
        and     %00111111       ; 0 to 63
        ld      h,a             ; Save column in H
        push    hl              ; Re-save column
        push    bc              ; Put back return
        ld      a,e             ; Get row
        ret

SMOTOR: call    CASFF           ; Flip tape drive
        ld      a,(hl)          ; Get byte
        ret

JPLDSV: ld      a,(BRKLIN)      ; CLOAD or CSAVE?
        cp      -1
        jp      nz,SNDHDR       ; CSAVE - Send header
        jp      GETHDR          ; CLOAD - Get header

CRLIN1: call    PRNTCR          ; Output CRLF
        jp      GETLIN          ; Get an input line

CRLIN:  call    PRNTCR          ; Output CRLF
        jp      GETLIN          ; Get an input line

TSTBIT: push    af              ; Save bit mask
        and     b               ; Get common bits
        pop     bc              ; Restore bit mask
        cp      b               ; Same bit set?
        ld      a,0             ; Return 0 in A
        ret

OUTNCR: call    OUTC            ; Output character in A
        jp      PRNTCR          ; Output CRLF

JJUMP:  jp      JJUMP1          ; "Cool" start

ZJUMP:  jp      BRKRET          ; Warm start

; Tell the emulator that all these bytes are executable.
; Why? Because parts of this source plant instructions using "db" and if you set "Trap on Error" then
; Zeus will (correctly, IMO) decide that executing those byte is an error and trap.

        mem_code START,*-START  ; We can read/execute all of these bytes

; Tell the emulator that this lives in ROM to prevent it being overwritten

        mem_rom  START,*-START  ; This is actually a ROM (Tells the emulator it cannot be written)

